
''!CsoundOpcode functions add: ('a' -> 'opa.html')!

''!CsoundOpcode functions add: ('abs' -> 'abs.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'active';
spec: 'x active x';
fullSpec: 'ir active insnum
kr active kinsnum';
doc: 'Returns the number of active instances of an instrument.';
html: 'active.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'adsr';
spec: 'x adsr iiiii';
fullSpec: 'ar adsr iatt, idec, islev, irel [, idel]
kr adsr iatt, idec, islev, irel [, idel]';
doc: 'Calculates the classical ADSR envelope using linear segments.';
html: 'adsr.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'adsyn';
spec: 'a adsyn kkki';
fullSpec: 'ar adsyn kamod, kfmod, ksmod, ifilcod';
doc: 'Output is an additive set of individually controlled sinusoids, using an oscillator bank.';
html: 'adsyn.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'adsynt';
spec: 'a adsynt kkiiiii';
fullSpec: 'ar adsynt kamp, kcps, iwfn, ifreqfn, iampfn, icnt [, iphs]';
doc: 'Performs additive synthesis with an arbitrary number of partials, not necessarily harmonic.';
html: 'adsynt.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'aftouch';
spec: 'k aftouch ii';
fullSpec: 'kaft aftouch [imin] [, imax]';
doc: 'Get the current after-touch value for this channel.';
html: 'aftouch.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'alpass';
spec: 'a alpass akiii';
fullSpec: 'ar alpass asig, krvt, ilpt [, iskip] [, insmps]';
doc: 'Reverberates an input signal with a flat frequency response.';
html: 'alpass.html')!

''!CsoundOpcode functions add: ('ampdb' -> 'ampdb.html')!

''!CsoundOpcode functions add: ('ampdbfs' -> 'ampdbfs.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'ampmidi';
spec: 'i ampmidi ii';
fullSpec: 'iamp ampmidi iscal [, ifn]';
doc: 'Get the velocity of the current MIDI event.';
html: 'ampmidi.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'areson';
spec: 'a areson akkii';
fullSpec: 'ar areson asig, kcf, kbw [, iscl] [, iskip]';
doc: 'A notch filter whose transfer functions are the complements of the reson opcode.';
html: 'areson.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'aresonk';
spec: 'k aresonk kkkii';
fullSpec: 'kr aresonk ksig, kcf, kbw [, iscl] [, iskip]';
doc: 'A notch filter whose transfer functions are the complements of the reson opcode.';
html: 'aresonk.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'atone';
spec: 'a atone aki';
fullSpec: 'ar atone asig, khp [, iskip]';
doc: 'A notch filter whose transfer functions are the complements of the tone opcode.';
html: 'atone.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'atonek';
spec: 'k atonek kki';
fullSpec: 'kr atonek ksig, khp [, iskip]';
doc: 'A notch filter whose transfer functions are the complements of the tone opcode.';
html: 'atonek.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'atonex';
spec: 'a atonex akii';
fullSpec: 'ar atonex asig, khp [, inumlayer] [, iskip]';
doc: 'atonex is equivalent to a filter consisting of more layers of atone with the same arguments, serially connected. Using a stack of a larger number of filters allows a sharper cutoff. They are faster than using a larger number instances in a Csound orchestra of the old opcodes, because only one initialization and k- cycle are needed at time and the audio loop falls entirely inside the cache memory of processor.';
html: 'atonex.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'babo';
spec: 'aa babo akkkiiiii';
fullSpec: 'a1, a2 babo asig, ksrcx, ksrcy, ksrcz, irx, iry, irz [, idiff] [, ifno]';
doc: 'babo  stands  for  ball-within-the-box.   It is a physical model reverberator based on the paper by Davide  Rocchesso "The  Ball  within  the Box: a sound-processing metaphor", Computer Music Journal,  Vol  19,  N.4,  pp.45-47,  Winter 1995.';
html: 'babo.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'balance';
spec: 'a balance aaii';
fullSpec: 'ar balance asig, acomp [, ihp] [, iskip]';
doc: 'The rms power of asig can be interrogated, set, or adjusted to match that of a comparator signal.';
html: 'balance.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'bamboo';
spec: 'a bamboo kiiiiiii';
fullSpec: 'ar bamboo kamp, idettack [, inum] [, idamp] [, imaxshake] [, ifreq] [, ifreq1] [, ifreq2]';
doc: 'bamboo is a semi-physical model of a bamboo sound. It is one of the PhISEM percussion opcodes. PhISEM (Physically Informed Stochastic Event Modeling) is an algorithmic approach for simulating collisions of multiple independent sound producing objects.';
html: 'bamboo.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'bbcutm';
spec: 'a bbcutm aiiiiiiii';
fullSpec: 'a1 bbcutm asource, ibps, isubdiv, ibarlength, iphrasebars, inumrepeats [, istutterspeed] [, istutterchance] [, ienvchoice ]';
doc: 'The BreakBeat Cutter automatically generates cut-ups of a source audio stream in the style of drum and bass/jungle breakbeat manipulations.  There are two versions, for mono (bbcutm) or stereo (bbcuts) sources.  Whilst originally based on breakbeat cutting, the opcode can be applied to any type of source audio.';
html: 'bbcutm.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'bbcuts';
spec: 'aa bbcuts aaiiiiiiii';
fullSpec: 'a1,a2 bbcuts asource1, asource2, ibps, isubdiv, ibarlength, iphrasebars, inumrepeats [, istutterspeed] [, istutterchance] [, ienvchoice]';
doc: 'The BreakBeat Cutter automatically generates cut-ups of a source audio stream in the style of drum and bass/jungle breakbeat manipulations.  There are two versions, for mono (bbcutm) or stereo (bbcuts) sources.  Whilst originally based on breakbeat cutting, the opcode can be applied to any type of source audio.';
html: 'bbcuts.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'betarand';
spec: 'x betarand kkk';
fullSpec: 'ar betarand krange, kalpha, kbeta
ir betarand krange, kalpha, kbeta
kr betarand krange, kalpha, kbeta';
doc: 'Beta distribution random number generator (positive values only). This is an x-class noise generator.';
html: 'betarand.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'bexprnd';
spec: 'x bexprnd k';
fullSpec: 'ar bexprnd krange
ir bexprnd krange
kr bexprnd krange';
doc: 'Exponential distribution random number generator. This is an x-class noise generator.';
html: 'bexprnd.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'biquad';
spec: 'a biquad akkkkkki';
fullSpec: 'ar biquad asig, kb0, kb1, kb2, ka0, ka1, ka2 [, iskip]';
doc: 'A sweepable general purpose biquadratic digital filter.';
html: 'biquad.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'biquada';
spec: 'a biquada aaaaaaai';
fullSpec: 'ar biquada asig, ab0, ab1, ab2, aa0, aa1, aa2 [, iskip]';
doc: 'A sweepable general purpose biquadratic digital filter.';
html: 'biquada.html')!

''!CsoundOpcode functions add: ('birnd' -> 'birnd.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'bqrez';
spec: 'a bqrez axxi';
fullSpec: 'ar bqrez asig, xfco, xres [, imode]';
doc: 'A second-order multi-mode filter.';
html: 'bqrez.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'butbp';
spec: 'a butbp akki';
fullSpec: 'ar butbp asig, kfreq, kband [, iskip]';
doc: 'Same as the butterbp opcode.';
html: 'butbp.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'butbr';
spec: 'a butbr akki';
fullSpec: 'ar butbr asig, kfreq, kband [, iskip]';
doc: 'Same as the butterbr opcode.';
html: 'butbr.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'buthp';
spec: 'a buthp aki';
fullSpec: 'ar buthp asig, kfreq [, iskip]';
doc: 'Same as the butterhp opcode.';
html: 'buthp.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'butlp';
spec: 'a butlp aki';
fullSpec: 'ar butlp asig, kfreq [, iskip]';
doc: 'Same as the butterlp opcode.';
html: 'butlp.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'butterbp';
spec: 'a butterbp akki';
fullSpec: 'ar butterbp asig, kfreq, kband [, iskip]';
doc: 'Implementation of a second-order band-pass Butterworth filter. This opcode can also be written as butbp.';
html: 'butterbp.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'butterbr';
spec: 'a butterbr akki';
fullSpec: 'ar butterbr asig, kfreq, kband [, iskip]';
doc: 'Implementation of a second-order band-reject Butterworth filter. This opcode can also be written as butbr.';
html: 'butterbr.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'butterhp';
spec: 'a butterhp aki';
fullSpec: 'ar butterhp asig, kfreq [, iskip]';
doc: 'Implementation of second-order high-pass Butterworth filter. This opcode can also be written as buthp.';
html: 'butterhp.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'butterlp';
spec: 'a butterlp aki';
fullSpec: 'ar butterlp asig, kfreq [, iskip]';
doc: 'Implementation of a second-order low-pass Butterworth filter. This opcode can also be written as butlp.';
html: 'butterlp.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'buzz';
spec: 'a buzz xxkii';
fullSpec: 'ar buzz xamp, xcps, knh, ifn [, iphs]';
doc: 'Output is a set of harmonically related sine partials.';
html: 'buzz.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'cabasa';
spec: 'a cabasa iiiii';
fullSpec: 'ar cabasa iamp, idettack [, inum] [, idamp] [, imaxshake]';
doc: 'cabasa is a semi-physical model of a cabasa sound. It is one of the PhISEM percussion opcodes. PhISEM (Physically Informed Stochastic Event Modeling) is an algorithmic approach for simulating collisions of multiple independent sound producing objects.';
html: 'cabasa.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'cauchy';
spec: 'x cauchy k';
fullSpec: 'ar cauchy kalpha
ir cauchy kalpha
kr cauchy kalpha';
doc: 'Cauchy distribution random number generator. This is an x-class noise generator.';
html: 'cauchy.html')!

''!CsoundOpcode functions add: ('cent' -> 'cent.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'cggoto';
spec: ' cggoto Xl';
fullSpec: 'cggoto condition, label
      where label is in the same instrument block and is not an expression, and where R is one of the Relational operators (&#60;, =, &#60;=, ==, =) (and = for convenience, see also under Conditional Values).    ';
doc: 'Transfer control to label on every pass. (Combination of cigoto and ckgoto) ';
html: 'cggoto.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'chanctrl';
spec: 'x chanctrl iiii';
fullSpec: 'ival chanctrl ichnl, ictlno [, ilow] [, ihigh]
kval chanctrl ichnl, ictlno [, ilow] [, ihigh]';
doc: 'Get the current value of a controller and optionally map it onto specified range.';
html: 'chanctrl.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'cigoto';
spec: ' cigoto Xl';
fullSpec: 'cigoto condition, label
      where label is in the same instrument block and is not an expression, and where R is one of the Relational operators (&#60;, =, &#60;=, ==, =) (and = for convenience, see also under Conditional Values).    ';
doc: 'During the i-time pass only, unconditionally transfer control to the statement labeled by label.';
html: 'cigoto.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'ckgoto';
spec: ' ckgoto Xl';
fullSpec: 'ckgoto condition, label
      where label is in the same instrument block and is not an expression, and where R is one of the Relational operators (&#60;, =, &#60;=, ==, =) (and = for convenience, see also under Conditional Values).    ';
doc: 'During the p-time passes only, unconditionally transfer control to the statement labeled by label.';
html: 'ckgoto.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'clear';
spec: ' clear aaa';
fullSpec: 'clear avar1 [, avar2] [, avar3] [...]';
doc: 'clear zeroes a list of audio signals.';
html: 'clear.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'clfilt';
spec: 'a clfilt akiiiiii';
fullSpec: 'ar clfilt asig, kfreq, itype, inpol [, ikind] [, ipbr] [, isba] [, iskip]';
doc: 'Implements the classical standard analog filter types: low-pass and high-pass. They are implemented with the four classical kinds of filters: Butterworth, Chebyshev Type I, Chebyshev Type II, and Elliptical.  The number of poles may be any even number from 2 to 80.';
html: 'clfilt.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'clip';
spec: 'a clip aiii';
fullSpec: 'ar clip asig, imeth, ilimit [, iarg]';
doc: 'Clips an a-rate signal to a predefined limit, in a "soft" manner, using one of three methods.';
html: 'clip.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'clockoff';
spec: ' clockoff i';
fullSpec: 'clockoff inum';
doc: 'Stops one of a number of internal clocks.';
html: 'clockoff.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'clockon';
spec: ' clockon i';
fullSpec: 'clockon inum';
doc: 'Starts one of a number of internal clocks.';
html: 'clockon.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'cngoto';
spec: ' cngoto Xl';
fullSpec: 'cngoto condition, label
      where label is in the same instrument block and is not an expression, and where R is one of the Relational operators (&#60;, =, &#60;=, ==, =) (and = for convenience, see also under Conditional Values).    ';
doc: 'Transfers control on every pass when the condition is not true.';
html: 'cngoto.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'comb';
spec: 'a comb akiii';
fullSpec: 'ar comb asig, krvt, ilpt [, iskip] [, insmps]';
doc: 'Reverberates an input signal with a "colored" frequency response.';
html: 'comb.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'convle';
spec: 'aaaa convle aii';
fullSpec: 'ar1 [, ar2] [, ar3] [, ar4] convle ain, ifilcod [, ichannel]';
doc: 'Same as the convolve opcode. ';
html: 'convle.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'convolve';
spec: 'aaaa convolve aii';
fullSpec: 'ar1 [, ar2] [, ar3] [, ar4] convolve ain, ifilcod [, ichannel]';
doc: 'Output is the convolution of signal ain and the impulse response contained in ifilcod. If more than one output signal is supplied, each will be convolved with the same impulse response. Note that it is considerably more efficient to use one instance of the operator when processing a mono input to create stereo, or quad, outputs. ';
html: 'convolve.html')!

''!CsoundOpcode functions add: ('cos' -> 'cos.html')!

''!CsoundOpcode functions add: ('cosh' -> 'cosh.html')!

''!CsoundOpcode functions add: ('cosinv' -> 'cosinv.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'cps2pch';
spec: 'i cps2pch ii';
fullSpec: 'icps cps2pch ipch, iequal';
doc: 'Converts a pitch-class value into cycles-per-second (Hz) for equal divisions of the octave.';
html: 'cps2pch.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'cpsmidi';
spec: 'i cpsmidi ';
fullSpec: 'icps cpsmidi';
doc: 'Get the note number of the current MIDI event, expressed in cycles-per-second.';
html: 'cpsmidi.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'cpsmidib';
spec: 'x cpsmidib i';
fullSpec: 'icps cpsmidib [irange]
kcps cpsmidib [irange]';
doc: 'Get the note number of the current MIDI event and modify it by the current pitch-bend value, express it in cycles-per-second. ';
html: 'cpsmidib.html')!

''!CsoundOpcode functions add: ('cpsoct' -> 'cpsoct.html')!

''!CsoundOpcode functions add: ('cpspch' -> 'cpspch.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'cpstmid';
spec: 'i cpstmid i';
fullSpec: 'icps cpstmid ifn';
doc: 'This unit is similar to cpsmidi, but allows fully customized micro-tuning scales.';
html: 'cpstmid.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'cpstun';
spec: 'k cpstun kkk';
fullSpec: 'kcps cpstun ktrig, kindex, kfn';
doc: 'Returns micro-tuning values at k-rate.';
html: 'cpstun.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'cpstuni';
spec: 'i cpstuni ii';
fullSpec: 'icps cpstuni index, ifn';
doc: 'Returns micro-tuning values at init-rate.';
html: 'cpstuni.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'cpsxpch';
spec: 'i cpsxpch iiii';
fullSpec: 'icps cpsxpch ipch, iequal, irepeat, ibase';
doc: 'Converts a pitch-class value into cycles-per-second (Hz) for equal divisions of any interval. There is a restriction of no more than 100 equal divisions.';
html: 'cpsxpch.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'cpuprc';
spec: ' cpuprc ii';
fullSpec: 'cpuprc insnum, ipercent';
doc: 'Control allocation of cpu resources on a per-instrument basis, to optimize realtime output.';
html: 'cpuprc.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'cross2';
spec: 'a cross2 aaiiik';
fullSpec: 'ar cross2 ain1, ain2, isize, ioverlap, iwin, kbias';
doc: 'This is an implementation of cross synthesis using FFTs.';
html: 'cross2.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'crunch';
spec: 'a crunch iiiii';
fullSpec: 'ar crunch iamp, idettack [, inum] [, idamp] [, imaxshake]';
doc: 'crunch is a semi-physical model of a crunch sound. It is one of the PhISEM percussion opcodes. PhISEM (Physically Informed Stochastic Event Modeling) is an algorithmic approach for simulating collisions of multiple independent sound producing objects.';
html: 'crunch.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'ctrl14';
spec: 'x ctrl14 iiixxi';
fullSpec: 'idest ctrl14 ichan, ictlno1, ictlno2, imin, imax [, ifn]
kdest ctrl14 ichan, ictlno1, ictlno2, kmin, kmax [, ifn]';
doc: 'Allows a floating-point 14-bit MIDI signal scaled with a minimum and a maximum range.';
html: 'ctrl14.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'ctrl21';
spec: 'x ctrl21 iiiixxi';
fullSpec: 'idest ctrl21 ichan, ictlno1, ictlno2, ictlno3, imin, imax [, ifn]
kdest ctrl21 ichan, ictlno1, ictlno2, ictlno3, kmin, kmax [, ifn]';
doc: 'Allows a floating-point 21-bit MIDI signal scaled with a minimum and a maximum range.';
html: 'ctrl21.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'ctrl7';
spec: 'x ctrl7 iixxi';
fullSpec: 'idest ctrl7 ichan, ictlno, imin, imax [, ifn]
kdest ctrl7 ichan, ictlno, kmin, kmax [, ifn]';
doc: 'Allows a floating-point 7-bit MIDI signal scaled with a minimum and a maximum range.';
html: 'ctrl7.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'ctrlinit';
spec: ' ctrlinit iiiiiii';
fullSpec: 'ctrlinit ichnl, ictlno1, ival1 [, ictlno2] [, ival2] [, ictlno3] [, ival3] [,...ival32]';
doc: 'Sets the initial values for a set of MIDI controllers.';
html: 'ctrlinit.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'cuserrnd';
spec: 'x cuserrnd xxx';
fullSpec: 'aout cuserrnd kmin, kmax, ktableNum
iout cuserrnd imin, imax, itableNum
kout cuserrnd kmin, kmax, ktableNum';
doc: 'Continuous USER-defined-distribution RaNDom generator.';
html: 'cuserrnd.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'dam';
spec: 'a dam akiiii';
fullSpec: 'ar dam asig, kthreshold, icomp1, icomp2, irtime, iftime';
doc: 'This opcode dynamically modifies a gain value applied to the input sound ain by comparing its power level to a given threshold level. The signal will be compressed/expanded with different factors regarding that it is over or under the threshold.';
html: 'dam.html')!

''!CsoundOpcode functions add: ('db' -> 'db.html')!

''!CsoundOpcode functions add: ('dbamp' -> 'dbamp.html')!

''!CsoundOpcode functions add: ('dbfsamp' -> 'dbfsamp.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'dcblock';
spec: 'a dcblock ai';
fullSpec: 'ar dcblock ain [, igain]';
doc: 'Implements the DC blocking filter      Y[i]&nbsp;=&nbsp;X[i]&nbsp;-&nbsp;X[i-1]&nbsp;+&nbsp;(igain&nbsp;*&nbsp;Y[i-1])&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
html: 'dcblock.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'dconv';
spec: 'a dconv aii';
fullSpec: 'ar dconv asig, isize, ifn';
doc: 'A direct convolution opcode.';
html: 'dconv.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'delay';
spec: 'a delay aii';
fullSpec: 'ar delay asig, idlt [, iskip]';
doc: 'A signal can be read from or written into a delay path, or it can be automatically delayed by some time interval.';
html: 'delay.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'delay1';
spec: 'a delay1 ai';
fullSpec: 'ar delay1 asig [, iskip]';
doc: 'Delays an input signal by one sample.';
html: 'delay1.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'delayr';
spec: 'a delayr ii';
fullSpec: 'ar delayr idlt [, iskip]';
doc: 'Reads from an automatically established digital delay line.';
html: 'delayr.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'delayw';
spec: ' delayw a';
fullSpec: 'delayw asig';
doc: 'Writes the audio signal to a digital delay line.';
html: 'delayw.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'deltap';
spec: 'a deltap k';
fullSpec: 'ar deltap kdlt';
doc: 'Tap a delay line at variable offset times. ';
html: 'deltap.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'deltap3';
spec: 'a deltap3 x';
fullSpec: 'ar deltap3 xdlt';
doc: 'Taps a delay line at variable offset times, uses cubic interpolation.';
html: 'deltap3.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'deltapi';
spec: 'a deltapi x';
fullSpec: 'ar deltapi xdlt';
doc: 'Taps a delay line at variable offset times, uses interpolation.';
html: 'deltapi.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'deltapn';
spec: 'a deltapn x';
fullSpec: 'ar deltapn xnumsamps';
doc: 'Tap a delay line at variable offset times. ';
html: 'deltapn.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'deltapx';
spec: 'a deltapx ai';
fullSpec: 'aout deltapx adel, iwsize';
doc: 'deltapx is similar to deltapi or deltap3. However, it allows higher quality interpolation. This opcode can read from and write to a delayr/delayw delay line with interpolation. ';
html: 'deltapx.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'deltapxw';
spec: ' deltapxw aai';
fullSpec: 'deltapxw ain, adel, iwsize';
doc: 'deltapxw mixes the input signal to a delay line. This opcode can be mixed with reading units (deltap, deltapn, deltapi, deltap3, and deltapx) in any order; the actual delay time is the difference of the read and write time. This opcode can read from and write to a delayr/delayw delay line with interpolation. ';
html: 'deltapxw.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'diff';
spec: 'x diff xi';
fullSpec: 'ar diff asig [, iskip]
kr diff ksig [, iskip]';
doc: 'Modify a signal by differentiation.';
html: 'diff.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'diskin';
spec: 'aaaa diskin ikiii';
fullSpec: 'ar1 [,ar2] [, ar3] [, ar4] diskin ifilcod, kpitch [, iskiptim] [, iwraparound] [, iformat]';
doc: 'Reads audio data from an external device or stream and can alter its pitch.';
html: 'diskin.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'dispfft';
spec: ' dispfft xiiiii';
fullSpec: 'dispfft xsig, iprd, iwsiz [, iwtyp] [, idbout] [, iwtflg]';
doc: 'These units will print orchestra init-values, or produce graphic display of orchestra control signals and audio signals. Uses X11 windows if enabled, else (or if -g flag is set) displays are approximated in ASCII characters.';
html: 'dispfft.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'display';
spec: ' display xiii';
fullSpec: 'display xsig, iprd [, inprds] [, iwtflg]';
doc: 'These units will print orchestra init-values, or produce graphic display of orchestra control signals and audio signals. Uses X11 windows if enabled, else (or if -g flag is set) displays are approximated in ASCII characters.';
html: 'display.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'distort1';
spec: 'a distort1 akkkk';
fullSpec: 'ar distort1 asig, kpregain, kpostgain, kshape1, kshape2';
doc: 'Implementation of modified hyperbolic tangent distortion. distort1 can be used to generate wave shaping distortion based on a modification of the tanh function.';
html: 'distort1.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'divz';
spec: 'x divz xxx';
fullSpec: 'ar divz xa, xb, ksubst
ir divz ia, ib, isubst
kr divz ka, kb, ksubst';
doc: '      Safely divides two numbers.';
html: 'divz.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'downsamp';
spec: 'k downsamp ai';
fullSpec: 'kr downsamp asig [, iwlen]';
doc: 'Modify a signal by down-sampling.';
html: 'downsamp.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'dripwater';
spec: 'a dripwater kiiiiiii';
fullSpec: 'ar dripwater kamp, idettack [, inum] [, idamp] [, imaxshake] [, ifreq] [, ifreq1] [, ifreq2]';
doc: 'dripwater is a semi-physical model of a water drop. It is one of the PhISEM percussion opcodes. PhISEM (Physically Informed Stochastic Event Modeling) is an algorithmic approach for simulating collisions of multiple independent sound producing objects.';
html: 'dripwater.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'dumpk';
spec: ' dumpk kiii';
fullSpec: 'dumpk  ksig, ifilname, iformat, iprd';
doc: 'Periodically writes an orchestra control-signal value to a named external file in a specific format.';
html: 'dumpk.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'dumpk2';
spec: ' dumpk2 kkiii';
fullSpec: 'dumpk2 ksig1, ksig2, ifilname, iformat, iprd';
doc: 'Periodically writes two orchestra control-signal values to a named external file in a specific format.';
html: 'dumpk2.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'dumpk3';
spec: ' dumpk3 kkkiii';
fullSpec: 'dumpk3 ksig1, ksig2, ksig3, ifilname, iformat, iprd';
doc: 'Periodically writes three orchestra control-signal values to a named external file in a specific format.';
html: 'dumpk3.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'dumpk4';
spec: ' dumpk4 kkkkiii';
fullSpec: 'dumpk4 ksig1, ksig2, ksig3, ksig4, ifilname, iformat, iprd';
doc: 'Periodically writes four orchestra control-signal values to a named external file in a specific format.';
html: 'dumpk4.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'duserrnd';
spec: 'x duserrnd x';
fullSpec: 'aout duserrnd ktableNum
iout duserrnd itableNum
kout duserrnd ktableNum';
doc: 'Discrete USER-defined-distribution RaNDom generator.';
html: 'duserrnd.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'endin';
spec: ' endin ';
fullSpec: 'endin';
doc: 'Ends the current instrument block.';
html: 'endin.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'endop';
spec: ' endop ';
fullSpec: 'endop';
doc: 'Marks the end of an user-defined opcode block.';
html: 'endop.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'envlpx';
spec: 'x envlpx xiiiiiii';
fullSpec: 'ar envlpx xamp, irise, idur, idec, ifn, iatss, iatdec [, ixmod]
kr envlpx kamp, irise, idur, idec, ifn, iatss, iatdec [, ixmod]';
doc: 'envlpx -- apply an envelope consisting of 3 segments:      
stored function rise shape
modified exponential pseudo steady state
exponential decay';
html: 'envlpx.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'envlpxr';
spec: 'x envlpxr xiiiiiiii';
fullSpec: 'ar envlpxr xamp, irise, idur, idec, ifn, iatss, iatdec [, ixmod] [,irind]
kr envlpxr kamp, irise, idur, idec, ifn, iatss, iatdec [, ixmod] [,irind]';
doc: 'envlpxr is the same as envlpx except that the final segment is entered only on sensing a MIDI note release. The note is then extended by the decay time.';
html: 'envlpxr.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'event';
spec: ' event "kkkkk';
fullSpec: 'event "scorechar", kinsnum, kdelay, kdur, [, kp4] [, kp5] [, ...]
event "scorechar", "insname", kdelay, kdur, [, kp4] [, kp5] [, ...]';
doc: 'Generates a score event from an instrument.';
html: 'event.html')!

''!CsoundOpcode functions add: ('exp' -> 'exp.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'expon';
spec: 'x expon iii';
fullSpec: 'ar expon ia, idur1, ib
kr expon ia, idur1, ib';
doc: 'Trace an exponential curve between specified points.';
html: 'expon.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'exprand';
spec: 'x exprand k';
fullSpec: 'ar exprand krange
ir exprand krange
kr exprand krange';
doc: 'Exponential distribution random number generator (positive values only). This is an x-class noise generator.';
html: 'exprand.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'expseg';
spec: 'x expseg iiiii';
fullSpec: 'ar expseg ia, idur1, ib [, idur2] [, ic] [...]
kr expseg ia, idur1, ib [, idur2] [, ic] [...]';
doc: 'Trace a series of exponential segments between specified points.';
html: 'expseg.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'expsega';
spec: 'a expsega iiiii';
fullSpec: 'ar expsega ia, idur1, ib [, idur2] [, ic] [...]';
doc: 'An exponential segment generator operating at a-rate. This unit is almost identical to expseg, but more precise when defining segments with very short durations (i.e., in a percussive attack phase) at audio rate.';
html: 'expsega.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'expsegr';
spec: 'x expsegr iiiiiii';
fullSpec: 'ar expsegr ia, idur1, ib [, idur2] [, ic] [...], irel, iz
kr expsegr ia, idur1, ib [, idur2] [, ic] [...], irel, iz';
doc: 'Trace a series of exponential segments between specified points including a release segment.';
html: 'expsegr.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'filelen';
spec: 'i filelen i';
fullSpec: 'ir filelen ifilcod';
doc: 'Returns the length of a sound file.';
html: 'filelen.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'filenchnls';
spec: 'i filenchnls i';
fullSpec: 'ir filenchnls ifilcod';
doc: 'Returns the number of channels in a sound file.';
html: 'filenchnls.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'filepeak';
spec: 'i filepeak ii';
fullSpec: 'ir filepeak ifilcod [, ichnl]';
doc: 'Returns the peak absolute value of a sound file.';
html: 'filepeak.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'filesr';
spec: 'i filesr i';
fullSpec: 'ir filesr ifilcod';
doc: 'Returns the sample rate of a sound file.';
html: 'filesr.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'filter2';
spec: 'x filter2 xiiiiiiii';
fullSpec: 'ar filter2 asig, iM, iN, ib0, ib1, ..., ibM, ia1, ia2, ..., iaN
kr filter2 ksig, iM, iN, ib0, ib1, ..., ibM, ia1, ia2, ..., iaN';
doc: 'General purpose custom filter with time-varying pole control. The filter coefficients implement the following difference equation:      (1)*y(n)&nbsp;=&nbsp;b0*x[n]&nbsp;+&nbsp;b1*x[n-1]&nbsp;+...+&nbsp;bM*x[n-M]&nbsp;-&nbsp;a1*y[n-1]&nbsp;-...-&nbsp;aN*y[n-N]&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
html: 'filter2.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'fin';
spec: ' fin iiiaaa';
fullSpec: 'fin ifilename, iskipframes, iformat, ain1 [, ain2] [, ain3] [,...]';
doc: 'Read signals from a file at a-rate.';
html: 'fin.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'fini';
spec: ' fini iiiiii';
fullSpec: 'fini ifilename, iskipframes, iformat, in1 [, in2] [, in3] [, ...]';
doc: 'Read signals from a file at i-rate.';
html: 'fini.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'fink';
spec: ' fink iiikkk';
fullSpec: 'fink ifilename, iskipframes, iformat, kin1 [, kin2] [, kin3] [,...]';
doc: 'Read signals from a file at k-rate.';
html: 'fink.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'fiopen';
spec: 'i fiopen ii';
fullSpec: 'ihandle fiopen ifilename, imode';
doc: 'fiopen can be used to open a file in one of the specified modes.';
html: 'fiopen.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'flanger';
spec: 'a flanger aaki';
fullSpec: 'ar flanger asig, adel, kfeedback [, imaxd]';
doc: 'A user controlled flanger.';
html: 'flanger.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'fmb3';
spec: 'a fmb3 kkkkkkiiiii';
fullSpec: 'ar fmb3 kamp, kfreq, kc1, kc2, kvdepth, kvrate, ifn1, ifn2, ifn3, ifn4, ivfn';
doc: 'Uses FM synthesis to create a Hammond B3 organ sound. It comes from a family of FM sounds, all using 4 basic oscillators and various architectures, as used in the TX81Z synthesizer.';
html: 'fmb3.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'fmbell';
spec: 'a fmbell kkkkkkiiiii';
fullSpec: 'ar fmbell kamp, kfreq, kc1, kc2, kvdepth, kvrate, ifn1, ifn2, ifn3, ifn4, ivfn';
doc: 'Uses FM synthesis to create a tublar bell sound. It comes from a family of FM sounds, all using 4 basic oscillators and various architectures, as used in the TX81Z synthesizer.';
html: 'fmbell.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'fmmetal';
spec: 'a fmmetal kkkkkkiiiii';
fullSpec: 'ar fmmetal kamp, kfreq, kc1, kc2, kvdepth, kvrate, ifn1, ifn2, ifn3, ifn4, ivfn';
doc: 'Uses FM synthesis to create a "Heavy Metal" sound. It comes from a family of FM sounds, all using 4 basic oscillators and various architectures, as used in the TX81Z synthesizer.';
html: 'fmmetal.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'fmpercfl';
spec: 'a fmpercfl kkkkkkiiiii';
fullSpec: 'ar fmpercfl kamp, kfreq, kc1, kc2, kvdepth, kvrate, ifn1, ifn2, ifn3, ifn4, ivfn';
doc: 'Uses FM synthesis to create a percussive flute sound. It comes from a family of FM sounds, all using 4 basic oscillators and various architectures, as used in the TX81Z synthesizer.';
html: 'fmpercfl.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'fmrhode';
spec: 'a fmrhode kkkkkkiiiii';
fullSpec: 'ar fmrhode kamp, kfreq, kc1, kc2, kvdepth, kvrate, ifn1, ifn2, ifn3, ifn4, ivfn';
doc: 'Uses FM synthesis to create a Fender Rhodes electric piano sound. It comes from a family of FM sounds, all using 4 basic oscillators and various architectures, as used in the TX81Z synthesizer.';
html: 'fmrhode.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'fmvoice';
spec: 'a fmvoice kkkkkkiiiii';
fullSpec: 'ar fmvoice kamp, kfreq, kvowel, ktilt, kvibamt, kvibrate, ifn1, ifn2, ifn3, ifn4, ivibfn';
doc: 'FM Singing Voice Synthesis';
html: 'fmvoice.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'fmwurlie';
spec: 'a fmwurlie kkkkkkiiiii';
fullSpec: 'ar fmwurlie kamp, kfreq, kc1, kc2, kvdepth, kvrate, ifn1, ifn2, ifn3, ifn4, ivfn';
doc: 'Uses FM synthesis to create a Wurlitzer electric piano sound. It comes from a family of FM sounds, all using 4 basic oscillators and various architectures, as used in the TX81Z synthesizer.';
html: 'fmwurlie.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'fof';
spec: 'a fof xxxkkkkkiiiiiii';
fullSpec: 'ar fof xamp, xfund, xform, koct, kband, kris, kdur, kdec, iolaps, ifna, ifnb, itotdur [, iphs] [, ifmode] [, iskip]';
doc: 'Audio output is a succession of sinusoid bursts initiated at frequency xfund with a spectral peak at xform. For xfund above 25 Hz these bursts produce a speech-like formant with spectral characteristics determined by the k-input parameters. For lower fundamentals this generator provides a special form of granular synthesis.';
html: 'fof.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'fof2';
spec: 'a fof2 xxxkkkkkiiiikki';
fullSpec: 'ar fof2 xamp, xfund, xform, koct, kband, kris, kdur, kdec, iolaps, ifna, ifnb, itotdur, kphs, kgliss [, iskip]';
doc: 'Audio output is a succession of sinusoid bursts initiated at frequency xfund with a spectral peak at xform. For xfund above 25 Hz these bursts produce a speech-like formant with spectral characteristics determined by the k-input parameters. For lower fundamentals this generator provides a special form of granular synthesis.';
html: 'fof2.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'fog';
spec: 'a fog xxxakkkkkiiiiiii';
fullSpec: 'ar fog xamp, xdens, xtrans, aspd, koct, kband, kris, kdur, kdec, iolaps, ifna, ifnb, itotdur [, iphs] [, itmode] [, iskip]';
doc: 'Audio output is a succession of grains derived from data in a stored function table ifna. The local envelope of these grains and their timing is based on the model of fof synthesis and permits detailed control of the granular synthesis.';
html: 'fog.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'fold';
spec: 'a fold ak';
fullSpec: 'ar fold asig, kincr';
doc: 'Adds artificial foldover to an audio signal.';
html: 'fold.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'follow';
spec: 'a follow ai';
fullSpec: 'ar follow asig, idt';
doc: 'Envelope follower unit generator.';
html: 'follow.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'follow2';
spec: 'a follow2 akk';
fullSpec: 'ar follow2 asig, katt, krel';
doc: 'A controllable envelope extractor using the algorithm attributed to Jean-Marc Jot.';
html: 'follow2.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'foscil';
spec: 'a foscil xkxxkii';
fullSpec: 'ar foscil xamp, kcps, xcar, xmod, kndx, ifn [, iphs]';
doc: 'A basic frequency modulated oscillator.';
html: 'foscil.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'foscili';
spec: 'a foscili xkxxkii';
fullSpec: 'ar foscili xamp, kcps, xcar, xmod, kndx, ifn [, iphs]';
doc: 'Basic frequency modulated oscillator with linear interpolation.';
html: 'foscili.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'fout';
spec: ' fout iiaaaa';
fullSpec: 'fout ifilename, iformat, aout1 [, aout2, aout3,...,aoutN]';
doc: 'fout outputs N a-rate signals to a specified file of N channels.';
html: 'fout.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'fouti';
spec: ' fouti iiiiiii';
fullSpec: 'fouti ihandle, iformat, iflag, iout1 [, iout2, iout3,....,ioutN]';
doc: 'fouti output N i-rate signals to a specified file of N channels.';
html: 'fouti.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'foutir';
spec: ' foutir iiiiiii';
fullSpec: 'foutir ihandle, iformat, iflag, iout1 [, iout2, iout3,....,ioutN]';
doc: 'foutir output N i-rate signals to a specified file of N channels.';
html: 'foutir.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'foutk';
spec: ' foutk iikkkk';
fullSpec: 'foutk ifilename, iformat, kout1 [, kout2, kout3,....,koutN]';
doc: 'foutk outputs N a-rate signals to a specified file of N channels.';
html: 'foutk.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'fprintks';
spec: ' fprintks "kk';
fullSpec: 'fprintks "filename", "string", [, kval1] [, kval2] [...]';
doc: 'Similar to printks but prints to a file.';
html: 'fprintks.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'fprints';
spec: ' fprints "kk';
fullSpec: 'fprints "filename", "string" [, kval1] [, kval2] [...]';
doc: 'Similar to prints but prints to a file.';
html: 'fprints.html')!

''!CsoundOpcode functions add: ('frac' -> 'frac.html')!

''!CsoundOpcode functions add: ('ftchnls' -> 'ftchnls.html')!

''!CsoundOpcode functions add: ('ftlen' -> 'ftlen.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'ftload';
spec: ' ftload "iii';
fullSpec: 'ftload "filename", iflag, ifn1 [, ifn2] [...]';
doc: 'Load a set of previously-allocated tables from a file.';
html: 'ftload.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'ftloadk';
spec: ' ftloadk "kiii';
fullSpec: 'ftloadk "filename", ktrig, iflag, ifn1 [, ifn2] [...]';
doc: 'Load a set of previously-allocated tables from a file.';
html: 'ftloadk.html')!

''!CsoundOpcode functions add: ('ftlptim' -> 'ftlptim.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'ftmorf';
spec: ' ftmorf kii';
fullSpec: 'ftmorf kftndx, iftfn, iresfn';
doc: 'Uses an index into a table of ftable numbers to morph between adjacent tables in the list.This morphed function is written into the table referenced by iresfn on every k-cycle.';
html: 'ftmorf.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'ftsave';
spec: ' ftsave "iii';
fullSpec: 'ftsave "filename", iflag, ifn1 [, ifn2] [...]';
doc: 'Save a set of previously-allocated tables to a file.';
html: 'ftsave.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'ftsavek';
spec: ' ftsavek "kiii';
fullSpec: 'ftsavek "filename", ktrig, iflag, ifn1 [, ifn2] [...]';
doc: 'Save a set of previously-allocated tables to a file.';
html: 'ftsavek.html')!

''!CsoundOpcode functions add: ('ftsr' -> 'ftsr.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'gain';
spec: 'a gain akii';
fullSpec: 'ar gain asig, krms [, ihp] [, iskip]';
doc: 'Adjusts the amplitude audio signal according to a root-mean-square value.';
html: 'gain.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'gauss';
spec: 'x gauss k';
fullSpec: 'ar gauss krange
ir gauss krange
kr gauss krange';
doc: 'Gaussian distribution random number generator. This is an x-class noise generator.';
html: 'gauss.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'gbuzz';
spec: 'a gbuzz xxkkkii';
fullSpec: 'ar gbuzz xamp, xcps, knh, klh, kmul, ifn [, iphs]';
doc: 'Output is a set of harmonically related cosine partials.';
html: 'gbuzz.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'gogobel';
spec: 'a gogobel kkiiikki';
fullSpec: 'ar gogobel kamp, kfreq, ihrd, ipos, imp, kvibf, kvamp, ivfn';
doc: 'Audio output is a tone related to the striking of a cow bell or similar. The method is a physical model developed from Perry Cook, but re-coded for Csound.';
html: 'gogobel.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'goto';
spec: ' goto l';
fullSpec: 'goto label
      where label is in the same instrument block and is not an expression, and where R is one of the Relational operators (&#60;, =, &#60;=, ==, =) (and = for convenience, see also under Conditional Values).    ';
doc: 'Transfer control to label on every pass. (Combination of igoto and kgoto) ';
html: 'goto.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'grain';
spec: 'a grain xxxkkkiiii';
fullSpec: 'ar grain xamp, xpitch, xdens, kampoff, kpitchoff, kgdur, igfn, iwfn, imgdur [, igrnd]';
doc: 'Generates granular synthesis textures.';
html: 'grain.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'grain2';
spec: 'a grain2 kkkikiiii';
fullSpec: 'ar grain2 kcps, kfmd, kgdur, iovrlp, kfn, iwfn [, irpow] [, iseed] [, imode]';
doc: 'Generate granular synthesis textures. grain2 is simpler to use, but grain3 offers more control.';
html: 'grain2.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'grain3';
spec: 'a grain3 kkkkkkikikkii';
fullSpec: 'ar grain3 kcps, kphs, kfmd, kpmd, kgdur, kdens, imaxovr, kfn, iwfn, kfrpow, kprpow [, iseed] [, imode]';
doc: 'Generate granular synthesis textures. grain2 is simpler to use but grain3 offers more control.';
html: 'grain3.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'granule';
spec: 'a granule xiiiiiiiiikikiiiiiiiii';
fullSpec: 'ar granule xamp, ivoice, iratio, imode, ithd, ifn, ipshift, igskip, igskip_os, ilength, kgap, igap_os, kgsize, igsize_os, iatt, idec [, iseed] [, ipitch1] [, ipitch2] [, ipitch3] [, ipitch4] [, ifnenv]';
doc: 'The granule unit generator is more complex than grain, but does add new possibilities.';
html: 'granule.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'guiro';
spec: 'a guiro kiiiiii';
fullSpec: 'ar guiro kamp, idettack [, inum] [, idamp] [, imaxshake] [, ifreq] [, ifreq1]';
doc: 'guiro is a semi-physical model of a guiro sound. It is one of the PhISEM percussion opcodes. PhISEM (Physically Informed Stochastic Event Modeling) is an algorithmic approach for simulating collisions of multiple independent sound producing objects.';
html: 'guiro.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'harmon';
spec: 'a harmon akkkkiii';
fullSpec: 'ar harmon asig, kestfrq, kmaxvar, kgenfreq1, kgenfreq2, imode, iminfrq, iprd';
doc: 'Analyze an audio input and generate harmonizing voices in synchrony.';
html: 'harmon.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'hilbert';
spec: 'aa hilbert a';
fullSpec: 'ar1, ar2 hilbert asig';
doc: 'An IIR implementation of a Hilbert transformer.';
html: 'hilbert.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'hrtfer';
spec: 'aa hrtfer akk"';
fullSpec: 'aleft, aright hrtfer asig, kaz, kelev, "HRTFcompact"';
doc: 'Output is binaural (headphone) 3D audio.';
html: 'hrtfer.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'hsboscil';
spec: 'a hsboscil kkkiiiii';
fullSpec: 'ar hsboscil kamp, ktone, kbrite, ibasfreq, iwfn, ioctfn [, ioctcnt] [, iphs]';
doc: 'An oscillator which takes tonality and brightness as arguments, relative to a base frequency.';
html: 'hsboscil.html')!

''!CsoundOpcode functions add: ('i' -> 'opi.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'igoto';
spec: ' igoto l';
fullSpec: 'igoto label
      where label is in the same instrument block and is not an expression, and where R is one of the Relational operators (&#60;, =, &#60;=, ==, =) (and = for convenience, see also under Conditional Values).    ';
doc: 'During the i-time pass only, unconditionally transfer control to the statement labeled by label.';
html: 'igoto.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'ihold';
spec: ' ihold ';
fullSpec: 'ihold';
doc: 'Causes a finite-duration note to become a "held" note';
html: 'ihold.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'in';
spec: 'a in ';
fullSpec: 'ar1 in';
doc: 'Reads mono audio data from an external device or stream.';
html: 'in.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'in32';
spec: 'aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa in32 ';
fullSpec: 'ar1, ar2, ar3, ar4, ar5, ar6, ar7, ar8, ar9, ar10, ar11, ar12, ar13, ar14, ar15, ar16, ar17, ar18, ar19, ar20, ar21, ar22, ar23, ar24, ar25, ar26, ar27, ar28, ar29, ar30, ar31, ar32 in32';
doc: 'Reads a 32-channel audio signal from an external device or stream.';
html: 'in32.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'inch';
spec: 'a inch k';
fullSpec: 'ar1 inch ksig1';
doc: 'Reads from a numbered channel in an external audio signal or stream.';
html: 'inch.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'inh';
spec: 'aaaaaa inh ';
fullSpec: 'ar1, ar2, ar3, ar4, ar5, ar6 inh';
doc: 'Reads six-channel audio data from an external device or stream.';
html: 'inh.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'init';
spec: 'x init i';
fullSpec: 'ar init iarg
ir init iarg
kr init iarg';
doc: '      Put the value of the i-time expression into a k- or a-rate variable.';
html: 'init.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'initc14';
spec: ' initc14 iiii';
fullSpec: 'initc14 ichan, ictlno1, ictlno2, ivalue';
doc: 'Initializes the controllers used to create a 14-bit MIDI value.';
html: 'initc14.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'initc21';
spec: ' initc21 iiiii';
fullSpec: 'initc21 ichan, ictlno1, ictlno2, ictlno3, ivalue';
doc: 'Initializes MIDI controller ictlno with ivalue';
html: 'initc21.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'initc7';
spec: ' initc7 iii';
fullSpec: 'initc7 ichan, ictlno, ivalue';
doc: 'Initializes MIDI controller ictlno with ivalue';
html: 'initc7.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'ino';
spec: 'aaaaaaaa ino ';
fullSpec: 'ar1, ar2, ar3, ar4, ar5, ar6, ar7, ar8 ino';
doc: 'Reads eight-channel audio data from an external device or stream.';
html: 'ino.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'inq';
spec: 'aaaa inq ';
fullSpec: 'ar1, ar2,  ar3, a4 inq';
doc: 'Reads quad audio data from an external device or stream.';
html: 'inq.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'ins';
spec: 'aa ins ';
fullSpec: 'ar1, ar2 ins';
doc: 'Reads stereo audio data from an external device or stream.';
html: 'ins.html')!

''!CsoundOpcode functions add: ('int' -> 'int.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'integ';
spec: 'x integ xi';
fullSpec: 'ar integ asig [, iskip]
kr integ ksig [, iskip]';
doc: 'Modify a signal by integration.';
html: 'integ.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'interp';
spec: 'a interp kii';
fullSpec: 'ar interp ksig [, iskip] [, imode]';
doc: 'Converts a control signal to an audio signal using linear interpolation.';
html: 'interp.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'invalue';
spec: 'k invalue "';
fullSpec: 'kvalue invalue "channel name"';
doc: 'Reads a k-rate signal from a user-defined channel.';
html: 'invalue.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'inx';
spec: 'aaaaaaaaaaaaaaaa inx ';
fullSpec: 'ar1, ar2, ar3, ar4, ar5, ar6, ar7, ar8, ar9, ar10, ar11, ar12, ar13, ar14, ar15, ar16 inx';
doc: 'Reads a 16-channel audio signal from an external device or stream.';
html: 'inx.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'inz';
spec: ' inz k';
fullSpec: 'inz ksig1';
doc: 'Reads multi-channel audio samples into a ZAK array from an external device or stream.';
html: 'inz.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'jitter';
spec: 'k jitter kkk';
fullSpec: 'kout jitter kamp, kcpsMin, kcpsMax';
doc: 'Generates a segmented line whose segments are randomly generated.';
html: 'jitter.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'jitter2';
spec: 'k jitter2 kkkkkkk';
fullSpec: 'kout jitter2 ktotamp, kamp1, kcps1, kamp2, kcps2, kamp3, kcps3';
doc: 'Generates a segmented line with user-controllable random segments.';
html: 'jitter2.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'jspline';
spec: 'x jspline xkk';
fullSpec: 'ar jspline xamp, kcpsMin, kcpsMax
kr jspline kamp, kcpsMin, kcpsMax';
doc: 'A jitter-spline generator.';
html: 'jspline.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'kgoto';
spec: ' kgoto l';
fullSpec: 'kgoto label
      where label is in the same instrument block and is not an expression, and where R is one of the Relational operators (&#60;, =, &#60;=, ==, =) (and = for convenience, see also under Conditional Values).    ';
doc: 'During the p-time passes only, unconditionally transfer control to the statement labeled by label.';
html: 'kgoto.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'ktableseg';
spec: ' ktableseg iiiii';
fullSpec: 'ktableseg ifn1, idur1, ifn2 [, idur2] [, ifn3] [...]';
doc: 'Same as the tableseg opcode.';
html: 'ktableseg.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'lfo';
spec: 'x lfo kki';
fullSpec: 'kr lfo kamp, kcps [, itype]
ar lfo kamp, kcps [, itype]';
doc: 'A low frequency oscillator of various shapes.';
html: 'lfo.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'limit';
spec: 'x limit xxx';
fullSpec: 'ar limit asig, klow, khigh
ir limit isig, ilow, ihigh
kr limit ksig, klow, khigh';
doc: 'Sets the lower and upper limits of the value it processes.';
html: 'limit.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'line';
spec: 'x line iii';
fullSpec: 'ar line ia, idur1, ib
kr line ia, idur1, ib';
doc: 'Trace a straight line between specified points.';
html: 'line.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'linen';
spec: 'x linen xiii';
fullSpec: 'ar linen xamp, irise, idur, idec
kr linen kamp, irise, idur, idec';
doc: 'linen -- apply a straight line rise and decay pattern to an input amp signal.';
html: 'linen.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'linenr';
spec: 'x linenr xiii';
fullSpec: 'ar linenr xamp, irise, idec, iatdec
kr linenr kamp, irise, idec, iatdec';
doc: 'linenr -- same as linen except that the final segment is entered only on sensing a MIDI note release. The note is then extended by the decay time.';
html: 'linenr.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'lineto';
spec: 'k lineto kk';
fullSpec: 'kr lineto ksig, ktime';
doc: 'Generate glissandos starting from a control signal.';
html: 'lineto.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'linrand';
spec: 'x linrand k';
fullSpec: 'ar linrand krange
ir linrand krange
kr linrand krange';
doc: 'Linear distribution random number generator (positive values only). This is an x-class noise generator.';
html: 'linrand.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'linseg';
spec: 'x linseg iiiii';
fullSpec: 'ar linseg ia, idur1, ib [, idur2] [, ic] [...]
kr linseg ia, idur1, ib [, idur2] [, ic] [...]';
doc: 'Trace a series of line segments between specified points.';
html: 'linseg.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'linsegr';
spec: 'x linsegr iiiiiii';
fullSpec: 'ar linsegr ia, idur1, ib [, idur2] [, ic] [...], irel, iz
kr linsegr ia, idur1, ib [, idur2] [, ic] [...], irel, iz';
doc: 'Trace a series of line segments between specified points including a release segment.';
html: 'linsegr.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'locsend';
spec: 'aa locsend ';
fullSpec: 'a1, a2 locsend
a1, a2,  a3, a4 locsend';
doc: 'locsend depends upon the existence of a previously defined locsig. The number of output signals must match the number in the previous locsig. The output signals from locsend are derived from the values given for distance and reverb in the locsig and are ready to be sent to local or global reverb units (see example below). The reverb amount and the balance between the 2 or 4 channels are calculated in the same way as described in the Dodge book (an essential text).';
html: 'locsend.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'locsig';
spec: 'aa locsig akkk';
fullSpec: 'a1, a2 locsig asig, kdegree, kdistance, kreverbsend
a1, a2,  a3, a4 locsig asig, kdegree, kdistance, kreverbsend';
doc: 'locsig takes an input signal and distributes it among 2 or 4 channels using values in degrees to calculate the balance between adjacent channels. It also takes arguments for distance (used to attenuate signals that are to sound as if they are some distance further than the loudspeaker itself), and for the amount the signal that will be sent to reverberators. This unit is based upon the example in the Charles Dodge/Thomas Jerse book, Computer Music, page 320.';
html: 'locsig.html')!

''!CsoundOpcode functions add: ('log' -> 'log.html')!

''!CsoundOpcode functions add: ('log10' -> 'log10.html')!

''!CsoundOpcode functions add: ('logbtwo' -> 'logbtwo.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'loopseg';
spec: 'k loopseg kkkkkkkk';
fullSpec: 'ksig loopseg kfreq, ktrig, ktime0, kvalue0 [, ktime1] [, kvalue1] [, ktime2] [, kvalue2] [...]';
doc: 'Generate control signal consisting of linear segments delimited by two or more specified points. The entire envelope is looped at kfreq rate. Each parameter can be varied at k-rate.';
html: 'loopseg.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'lorenz';
spec: 'aaa lorenz kkkkiiii';
fullSpec: 'ax, ay, az lorenz ksv, krv, kbv, kh, ix, iy, iz, iskip';
doc: 'Implements the Lorenz system of equations.  The Lorenz system is a chaotic-dynamic system which was originally used to simulate the motion of a particle in convection currents and simplified weather systems. Small differences in initial conditions rapidly lead to diverging values.  This is sometimes expressed as the butterfly effect. If a butterfly flaps its wings in Australia, it will have an effect on the weather in Alaska. This system is one of the milestones in the development of chaos theory. It is useful as a chaotic audio source or as a low frequency modulation source.';
html: 'lorenz.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'loscil';
spec: 'aa loscil xkiiiiiiii';
fullSpec: 'ar [,ar2] loscil xamp, kcps, ifn [, ibas] [, imod1] [, ibeg1] [, iend1] [, imod2,] [, ibeg2] [, iend2]';
doc: 'Read sampled sound (mono or stereo) from a table, with optional sustain and release looping.';
html: 'loscil.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'loscil3';
spec: 'aa loscil3 xkiiiiiiii';
fullSpec: 'ar [,ar2] loscil3 xamp, kcps, ifn [, ibas] [, imod1] [, ibeg1] [, iend1] [, imod2] [, ibeg2] [, iend2]';
doc: 'Read sampled sound from a table using cubic interpolation.';
html: 'loscil3.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'lowpass2';
spec: 'a lowpass2 akki';
fullSpec: 'ar lowpass2 asig, kcf, kq [, iskip]';
doc: 'Implementation of a resonant second-order lowpass filter.';
html: 'lowpass2.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'lowres';
spec: 'a lowres akki';
fullSpec: 'ar lowres asig, kcutoff, kresonance [, iskip]';
doc: 'lowres is a resonant lowpass filter.';
html: 'lowres.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'lowresx';
spec: 'a lowresx akkii';
fullSpec: 'ar lowresx asig, kcutoff, kresonance [, inumlayer] [, iskip]';
doc: 'lowresx is equivalent to more layers of lowres with the same arguments serially connected.';
html: 'lowresx.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'lpf18';
spec: 'a lpf18 akkk';
fullSpec: 'ar lpf18 asig, kfco, kres, kdist';
doc: 'Implementation of a 3 pole sweepable resonant lowpass filter.';
html: 'lpf18.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'lpfreson';
spec: 'a lpfreson ak';
fullSpec: 'ar lpfreson asig, kfrqratio';
doc: 'Modifies the spectrum of an audio signal with time-varying filter coefficients from a control file and frequncy ratio.';
html: 'lpfreson.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'lphasor';
spec: 'a lphasor xiiiii';
fullSpec: 'ar lphasor xtrns [, ilps] [, ilpe] [, imode] [, istrt] [, istor]';
doc: 'This opcode can be used to generate table index for sample playback (e.g. tablexkt).';
html: 'lphasor.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'lpinterp';
spec: ' lpinterp iik';
fullSpec: 'lpinterp islot1, islot2, kmix';
doc: 'Computes a new set of poles from the interpolation between two analysis.';
html: 'lpinterp.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'lposcil';
spec: 'a lposcil kkkkii';
fullSpec: 'ar lposcil kamp, kfreqratio, kloop, kend, ifn [, iphs]';
doc: 'Read sampled sound (mono or stereo) from a table, with optional sustain and release looping, and high precision.';
html: 'lposcil.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'lposcil3';
spec: 'a lposcil3 kkkkii';
fullSpec: 'ar lposcil3 kamp, kfreqratio, kloop, kend, ifn [, iphs]';
doc: 'Read sampled sound (mono or stereo) from a table, with optional sustain and release looping, and high precision. lposcil3 uses cubic interpolation.';
html: 'lposcil3.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'lpread';
spec: 'kkkk lpread kiii';
fullSpec: 'krmsr, krmso, kerr, kcps lpread ktimpnt, ifilcod [, inpoles] [, ifrmrate]';
doc: 'Reads a control file of time-ordered information frames.';
html: 'lpread.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'lpreson';
spec: 'a lpreson a';
fullSpec: 'ar lpreson asig';
doc: 'Modifies the spectrum of an audio signal with time-varying filter coefficients from a control file.';
html: 'lpreson.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'lpshold';
spec: 'k lpshold kkkkkkkk';
fullSpec: 'ksig lpshold kfreq, ktrig, ktime0, kvalue0  [, ktime1] [, kvalue1] [, ktime2] [, kvalue2] [...]';
doc: 'Generate control signal consisting of held segments delimited by two or more specified points. The entire envelope is looped at kfreq rate. Each parameter can be varied at k-rate.';
html: 'lpshold.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'lpslot';
spec: ' lpslot i';
fullSpec: 'lpslot islot';
doc: 'Selects the slot to be use by further lp opcodes.';
html: 'lpslot.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'mac';
spec: 'a mac akakak';
fullSpec: 'ar mac asig1, ksig1 [, asig2] [, ksig2] [, asig3] [, ksig3] [...]';
doc: 'Multiplies and accumulates a- and k-rate signals.';
html: 'mac.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'maca';
spec: 'a maca aaaaa';
fullSpec: 'ar maca asig1 [, asig2] [, asig3] [, asig4] [, asig5] [...]';
doc: 'Multiply and accumulate a-rate signals only.';
html: 'maca.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'madsr';
spec: 'x madsr iiiiii';
fullSpec: 'ar madsr iatt, idec, islev, irel [, idel] [, ireltim]
kr madsr iatt, idec, islev, irel [, idel] [, ireltim]';
doc: 'Calculates the classical ADSR envelope using the linsegr mechanism.';
html: 'madsr.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'mandol';
spec: 'a mandol kkkkkkii';
fullSpec: 'ar mandol kamp, kfreq, kpluck, kdetune, kgain, ksize, ifn [, iminfreq]';
doc: 'An emulation of a mandolin.';
html: 'mandol.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'marimba';
spec: 'a marimba kkiiikkiiii';
fullSpec: 'ar marimba kamp, kfreq, ihrd, ipos, imp, kvibf, kvamp, ivibfn, idec [, idoubles] [, itriples]';
doc: 'Audio output is a tone related to the striking of a wooden block as found in a marimba. The method is a physical model developed from Perry Cook but re-coded for Csound.';
html: 'marimba.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'massign';
spec: ' massign iX';
fullSpec: 'massign ichnl, insnum
massign ichnl, "insname"';
doc: 'Assigns a MIDI channel number to a Csound instrument.';
html: 'massign.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'maxalloc';
spec: ' maxalloc ii';
fullSpec: 'maxalloc insnum, icount';
doc: 'Limits the number of allocations of an instrument.';
html: 'maxalloc.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'mclock';
spec: ' mclock i';
fullSpec: 'mclock ifreq';
doc: 'Sends a MIDI CLOCK message.';
html: 'mclock.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'mdelay';
spec: ' mdelay kkkkk';
fullSpec: 'mdelay kstatus, kchan, kd1, kd2, kdelay';
doc: 'A MIDI delay opcode.';
html: 'mdelay.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'midic14';
spec: 'x midic14 iixxi';
fullSpec: 'idest midic14 ictlno1, ictlno2, imin, imax [, ifn]
kdest midic14 ictlno1, ictlno2, kmin, kmax [, ifn]';
doc: 'Allows a floating-point 14-bit MIDI signal scaled with a minimum and a maximum range.';
html: 'midic14.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'midic21';
spec: 'x midic21 iiixxi';
fullSpec: 'idest midic21 ictlno1, ictlno2, ictlno3, imin, imax [, ifn]
kdest midic21 ictlno1, ictlno2, ictlno3, kmin, kmax [, ifn]';
doc: 'Allows a floating-point 21-bit MIDI signal scaled with a minimum and a maximum range.';
html: 'midic21.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'midic7';
spec: 'x midic7 ixxi';
fullSpec: 'idest midic7 ictlno, imin, imax [, ifn]
kdest midic7 ictlno, kmin, kmax [, ifn]';
doc: 'Allows a floating-point 7-bit MIDI signal scaled with a minimum and a maximum range.';
html: 'midic7.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'midichannelaftertouch';
spec: ' midichannelaftertouch xii';
fullSpec: 'midichannelaftertouch xchannelaftertouch [, ilow] [, ihigh]';
doc: 'midichannelaftertouch is designed to simplify writing instruments that can be used interchangeably for either score or MIDI input, and to make it easier to adapt instruments originally written for score input to work with MIDI input.';
html: 'midichannelaftertouch.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'midichn';
spec: 'i midichn ';
fullSpec: 'ichn midichn';
doc: 'midichn returns the MIDI channel number (1 - 16) from which the note was activated. In the case of score notes, it returns 0.';
html: 'midichn.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'midicontrolchange';
spec: ' midicontrolchange xxii';
fullSpec: 'midicontrolchange xcontroller, xcontrollervalue [, ilow] [, ihigh]';
doc: 'midicontrolchange is designed to simplify writing instruments that can be used interchangeably for either score or MIDI input, and to make it easier to adapt instruments originally written for score input to work with MIDI input.';
html: 'midicontrolchange.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'midictrl';
spec: 'x midictrl iii';
fullSpec: 'ival midictrl inum [, imin] [, imax]
kval midictrl inum [, imin] [, imax]';
doc: 'Get the current value (0-127) of a specified MIDI controller.';
html: 'midictrl.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'mididefault';
spec: ' mididefault xx';
fullSpec: 'mididefault xdefault, xvalue';
doc: 'mididefault is designed to simplify writing instruments that can be used interchangeably for either score or MIDI input, and to make it easier to adapt instruments originally written for score input to work with MIDI input.';
html: 'mididefault.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'midiin';
spec: 'kkkk midiin ';
fullSpec: 'kstatus, kchan, kdata1, kdata2 midiin';
doc: 'Returns a generic MIDI message received by the MIDI IN port';
html: 'midiin.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'midinoteoff';
spec: ' midinoteoff xx';
fullSpec: 'midinoteoff xkey, xvelocity';
doc: 'midinoteoff is designed to simplify writing instruments that can be used interchangeably for either score or MIDI input, and to make it easier to adapt instruments originally written for score input to work with MIDI input.';
html: 'midinoteoff.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'midinoteoncps';
spec: ' midinoteoncps xx';
fullSpec: 'midinoteoncps xcps, xvelocity';
doc: 'midinoteoncps is designed to simplify writing instruments that can be used interchangeably for either score or MIDI input, and to make it easier to adapt instruments originally written for score input to work with MIDI input.';
html: 'midinoteoncps.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'midinoteonkey';
spec: ' midinoteonkey xx';
fullSpec: 'midinoteonkey xkey, xvelocity';
doc: 'midinoteonkey is designed to simplify writing instruments that can be used interchangeably for either score or MIDI input, and to make it easier to adapt instruments originally written for score input to work with MIDI input.';
html: 'midinoteonkey.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'midinoteonoct';
spec: ' midinoteonoct xx';
fullSpec: 'midinoteonoct xoct, xvelocity';
doc: 'midinoteonoct is designed to simplify writing instruments that can be used interchangeably for either score or MIDI input, and to make it easier to adapt instruments originally written for score input to work with MIDI input.';
html: 'midinoteonoct.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'midinoteonpch';
spec: ' midinoteonpch xx';
fullSpec: 'midinoteonpch xpch, xvelocity';
doc: 'midinoteonpch is designed to simplify writing instruments that can be used interchangeably for either score or MIDI input, and to make it easier to adapt instruments originally written for score input to work with MIDI input.';
html: 'midinoteonpch.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'midion';
spec: ' midion kkk';
fullSpec: 'midion kchn, knum, kvel';
doc: 'Plays MIDI notes.';
html: 'midion.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'midion2';
spec: ' midion2 kkkk';
fullSpec: 'midion2 kchn, knum, kvel, ktrig';
doc: 'Sends noteon and noteoff messages to the MIDI OUT port when triggered by a value different than zero.';
html: 'midion2.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'midiout';
spec: ' midiout kkkk';
fullSpec: 'midiout kstatus, kchan, kdata1, kdata2';
doc: 'Sends a generic MIDI message to the MIDI OUT port.';
html: 'midiout.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'midipitchbend';
spec: ' midipitchbend xii';
fullSpec: 'midipitchbend xpitchbend [, ilow] [, ihigh]';
doc: 'midipitchbend is designed to simplify writing instruments that can be used interchangeably for either score or MIDI input, and to make it easier to adapt instruments originally written for score input to work with MIDI input.';
html: 'midipitchbend.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'midipolyaftertouch';
spec: ' midipolyaftertouch xxii';
fullSpec: 'midipolyaftertouch xpolyaftertouch, xcontrollervalue [, ilow] [, ihigh]';
doc: 'midipolyaftertouch is designed to simplify writing instruments that can be used interchangeably for either score or MIDI input, and to make it easier to adapt instruments originally written for score input to work with MIDI input.';
html: 'midipolyaftertouch.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'midiprogramchange';
spec: ' midiprogramchange x';
fullSpec: 'midiprogramchange xprogram';
doc: 'midiprogramchange is designed to simplify writing instruments that can be used interchangeably for either score or MIDI input, and to make it easier to adapt instruments originally written for score input to work with MIDI input.';
html: 'midiprogramchange.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'mirror';
spec: 'x mirror xxx';
fullSpec: 'ar mirror asig, klow, khigh
ir mirror isig, ilow, ihigh
kr mirror ksig, klow, khigh';
doc: 'Reflects the signal that exceeds the low and high thresholds.';
html: 'mirror.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'moog';
spec: 'a moog kkkkkkiii';
fullSpec: 'ar moog kamp, kfreq, kfiltq, kfiltrate, kvibf, kvamp, iafn, iwfn, ivfn';
doc: 'An emulation of a mini-Moog synthesizer.';
html: 'moog.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'moogvcf';
spec: 'a moogvcf axxi';
fullSpec: 'ar moogvcf asig, xfco, xres [, iscale]';
doc: 'A digital emulation of the Moog diode ladder filter configuration.';
html: 'moogvcf.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'moscil';
spec: ' moscil kkkkk';
fullSpec: 'moscil kchn, knum, kvel, kdur, kpause';
doc: 'Sends a stream of the MIDI notes.';
html: 'moscil.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'mpulse';
spec: 'a mpulse kki';
fullSpec: 'ar mpulse kamp, kfreq [, ioffset]';
doc: 'Generates a set of impulses of amplitude kamp at frequency kfreq.  The first impulse is  after a delay of ioffset seconds. The value of kfreq is read only after an impulse, so it is the interval to the next impulse at the time of an impulse.';
html: 'mpulse.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'mrtmsg';
spec: ' mrtmsg i';
fullSpec: 'mrtmsg imsgtype';
doc: 'Send system real-time messages to the MIDI OUT port.';
html: 'mrtmsg.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'multitap';
spec: 'a multitap aiiii';
fullSpec: 'ar multitap asig [, itime1] [, igain1] [, itime2] [, igain2] [...]';
doc: 'Multitap delay line implementation.';
html: 'multitap.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'mute';
spec: ' mute Xi';
fullSpec: 'mute insnum [, iswitch]
mute "insname" [, iswitch]';
doc: 'Mutes/unmutes new instances of a given instrument.';
html: 'mute.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'mxadsr';
spec: 'x mxadsr iiiiii';
fullSpec: 'ar mxadsr iatt, idec, islev, irel [, idel] [, ireltim]
kr mxadsr iatt, idec, islev, irel [, idel] [, ireltim]';
doc: 'Calculates the classical ADSR envelope using the expsegr mechanism.';
html: 'mxadsr.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'nestedap';
spec: 'a nestedap aiiiiiiiii';
fullSpec: 'ar nestedap asig, imode, imaxdel, idel1, igain1 [, idel2] [, igain2] [, idel3] [, igain3] [, istor]';
doc: 'Three different nested all-pass filters, useful for implementing reverbs.';
html: 'nestedap.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'nlfilt';
spec: 'a nlfilt akkkkk';
fullSpec: 'ar nlfilt ain, ka, kb, kd, kC, kL';
doc: 'Implements the filter:      Y{n}&nbsp;=a&nbsp;Y{n-1}&nbsp;+&nbsp;b&nbsp;Y{n-2}&nbsp;+&nbsp;d&nbsp;Y^2{n-L}&nbsp;+&nbsp;X{n}&nbsp;-&nbsp;C&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
      described in Dobson and Fitch (ICMC96)';
html: 'nlfilt.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'noise';
spec: 'a noise xk';
fullSpec: 'ar noise xamp, kbeta';
doc: 'A white noise generator with an IIR lowpass filter.';
html: 'noise.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'noteoff';
spec: ' noteoff iii';
fullSpec: 'noteoff ichn, inum, ivel';
doc: 'Send a noteoff message to the MIDI OUT port.';
html: 'noteoff.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'noteon';
spec: ' noteon iii';
fullSpec: 'noteon ichn, inum, ivel';
doc: 'Send a noteon message to the MIDI OUT port.';
html: 'noteon.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'noteondur';
spec: ' noteondur iiii';
fullSpec: 'noteondur ichn, inum, ivel, idur';
doc: 'Sends a noteon and a noteoff MIDI message both with the same channel, number and velocity.';
html: 'noteondur.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'noteondur2';
spec: ' noteondur2 iiii';
fullSpec: 'noteondur2 ichn, inum, ivel, idur';
doc: 'Sends a noteon and a noteoff MIDI message both with the same channel, number and velocity.';
html: 'noteondur2.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'notnum';
spec: 'i notnum ';
fullSpec: 'ival notnum';
doc: 'Get a note number from a MIDI event.';
html: 'notnum.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'nreverb';
spec: 'a nreverb akkiiiii';
fullSpec: 'ar nreverb asig, ktime, khdif [, iskip] [,inumCombs] [, ifnCombs] [, inumAlpas] [, ifnAlpas]';
doc: 'This is a reverberator consisting of 6 parallel comb-lowpass filters being fed into a series of 5 allpass filters. nreverb replaces reverb2 (version 3.48) and so both opcodes are identical.';
html: 'nreverb.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'nrpn';
spec: ' nrpn kkk';
fullSpec: 'nrpn kchan, kparmnum, kparmvalue';
doc: 'Sends a NPRN (Non-Registered Parameter Number) message to the MIDI OUT port each time one of the input arguments changes.';
html: 'nrpn.html')!

''!CsoundOpcode functions add: ('nsamp' -> 'nsamp.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'nstrnum';
spec: 'i nstrnum "';
fullSpec: 'insno nstrnum "name"';
doc: 'Returns the number of a named instrument.';
html: 'nstrnum.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'ntrpol';
spec: 'x ntrpol xxxii';
fullSpec: 'ar ntrpol asig1, asig2, kpoint [, imin] [, imax]
ir ntrpol isig1, isig2, ipoint [, imin] [, imax]
kr ntrpol ksig1, ksig2, kpoint [, imin] [, imax]';
doc: 'Calculates the weighted mean value (i.e. linear interpolation) of two input signals';
html: 'ntrpol.html')!

''!CsoundOpcode functions add: ('octave' -> 'octave.html')!

''!CsoundOpcode functions add: ('octcps' -> 'octcps.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'octmidi';
spec: 'i octmidi ';
fullSpec: 'ioct octmidi';
doc: 'Get the note number, in octave-point-decimal units, of the current MIDI event.';
html: 'octmidi.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'octmidib';
spec: 'x octmidib i';
fullSpec: 'ioct octmidib [irange]
koct octmidib [irange]';
doc: 'Get the note number of the current MIDI event and modify it by the current pitch-bend value, express it in octave-point-decimal.';
html: 'octmidib.html')!

''!CsoundOpcode functions add: ('octpch' -> 'octpch.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'oscbnk';
spec: 'a oscbnk kkkkiikkkkikkkkkkikiiiiiii';
fullSpec: 'ar oscbnk  kcps, kamd, kfmd, kpmd, iovrlap, iseed, kl1minf, kl1maxf, kl2minf, kl2maxf, ilfomode, keqminf, keqmaxf, keqminl, keqmaxl, keqminq, keqmaxq, ieqmode, kfn [, il1fn] [, il2fn] [, ieqffn] [, ieqlfn] [, ieqqfn] [, itabl] [, ioutfn]';
doc: 'This unit generator mixes the output of any number of oscillators. The frequency, phase, and amplitude of each oscillator can be modulated by two LFOs (all oscillators have a separate set of LFOs, with different phase and frequency); additionally, the output of each oscillator can be filtered through an optional parametric equalizer (also controlled by the LFOs).  This opcode is most useful for rendering ensemble (strings, choir, etc.) instruments.';
html: 'oscbnk.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'oscil';
spec: 'x oscil xxii';
fullSpec: 'ar oscil  xamp, xcps, ifn [, iphs]
kr oscil  kamp, kcps, ifn [, iphs]';
doc: 'Table ifn is incrementally sampled modulo the table length and the value obtained is multiplied by amp.';
html: 'oscil.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'oscil1';
spec: 'k oscil1 ikii';
fullSpec: 'kr oscil1 idel, kamp, idur, ifn';
doc: 'Accesses table values by incremental sampling.';
html: 'oscil1.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'oscil1i';
spec: 'k oscil1i ikii';
fullSpec: 'kr oscil1i idel, kamp, idur, ifn';
doc: 'Accesses table values by incremental sampling with linear interpolation.';
html: 'oscil1i.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'oscil3';
spec: 'x oscil3 xxii';
fullSpec: 'ar oscil3 xamp, xcps, ifn [, iphs]
kr oscil3 kamp, kcps, ifn [, iphs]';
doc: 'Table ifn is incrementally sampled modulo the table length and the value obtained is multiplied by amp.';
html: 'oscil3.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'oscili';
spec: 'x oscili xxii';
fullSpec: 'ar oscili xamp, xcps, ifn [, iphs]
kr oscili kamp, kcps, ifn [, iphs]';
doc: 'Table ifn is incrementally sampled modulo the table length and the value obtained is multiplied by amp.';
html: 'oscili.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'oscilikt';
spec: 'x oscilikt xxkii';
fullSpec: 'ar oscilikt xamp, xcps, kfn [, iphs] [, istor]
kr oscilikt kamp, kcps, kfn [, iphs] [, istor]';
doc: 'oscilikt is very similar to oscili, but allows changing the table number at k-rate. It is slightly slower than oscili (especially with high control rate), although also more accurate as it uses a 31-bit phase accumulator, as opposed to the 24-bit one used by oscili.';
html: 'oscilikt.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'osciliktp';
spec: 'a osciliktp kkki';
fullSpec: 'ar osciliktp kcps, kfn, kphs [, istor]';
doc: 'osciliktp allows phase modulation (which is actually implemented as k-rate frequency modulation, by differentiating phase input). The disadvantage is that there is no amplitude control, and frequency can be varied only at the control-rate. This opcode can be faster or slower than oscilikt, depending on the control-rate.';
html: 'osciliktp.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'oscilikts';
spec: 'a oscilikts xxkaki';
fullSpec: 'ar oscilikts xamp, xcps, kfn, async, kphs [, istor]';
doc: 'oscilikts is the same as oscilikt. Except it has a sync input that can be used to re-initialize the oscillator to a k-rate phase value. It is slower than oscilikt and osciliktp.';
html: 'oscilikts.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'osciln';
spec: 'a osciln kiii';
fullSpec: 'ar osciln kamp, ifrq, ifn, itimes';
doc: 'Accesses table values at a user-defined frequency. This opcode can also be written as oscilx.';
html: 'osciln.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'oscils';
spec: 'a oscils iiii';
fullSpec: 'ar oscils iamp, icps, iphs [, iflg]';
doc: 'Simple, fast sine oscillator, that uses only one multiply, and two add operations to generate one sample of output, and does not require a function table.';
html: 'oscils.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'oscilx';
spec: 'a oscilx kiii';
fullSpec: 'ar oscilx kamp, ifrq, ifn, itimes';
doc: 'Same as the osciln opcode.';
html: 'oscilx.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'out';
spec: ' out a';
fullSpec: 'out asig';
doc: 'Writes mono audio data to an external device or stream.';
html: 'out.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'out32';
spec: ' out32 aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa';
fullSpec: 'out32 asig1, asig2, asig3, asig4, asig5, asig6, asig7, asig8, asig10, asig11, asig12, asig13, asig14, asig15, asig16, asig17, asig18, asig19, asig20, asig21, asig22, asig23, asig24, asig25, asig26, asig27, asig28, asig29, asig30, asig31, asig32';
doc: 'Writes 32-channel audio data to an external device or stream.';
html: 'out32.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'outc';
spec: ' outc aa';
fullSpec: 'outc asig1 [, asig2] [...]';
doc: 'Writes audio data with an arbitrary number of channels to an external device or stream.';
html: 'outc.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'outch';
spec: ' outch kaka';
fullSpec: 'outch ksig1, asig1 [, ksig2] [, asig2] [...]';
doc: 'Writes multi-channel audio data, with user-controllable channels, to an external device or stream.';
html: 'outch.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'outh';
spec: ' outh aaaaaa';
fullSpec: 'outh asig1, asig2, asig3, asig4, asig5, asig6';
doc: 'Writes 6-channel audio data to an external device or stream.';
html: 'outh.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'outiat';
spec: ' outiat iiii';
fullSpec: 'outiat ichn, ivalue, imin, imax';
doc: 'Sends MIDI aftertouch messages at i-rate.';
html: 'outiat.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'outic';
spec: ' outic iiiii';
fullSpec: 'outic ichn, inum, ivalue, imin, imax';
doc: 'Sends MIDI controller output at i-rate.';
html: 'outic.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'outic14';
spec: ' outic14 iiiiii';
fullSpec: 'outic14 ichn, imsb, ilsb, ivalue, imin, imax';
doc: 'Sends 14-bit MIDI controller output at i-rate.';
html: 'outic14.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'outipat';
spec: ' outipat iiiii';
fullSpec: 'outipat ichn, inotenum, ivalue, imin, imax';
doc: 'Sends polyphonic MIDI aftertouch messages at i-rate.';
html: 'outipat.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'outipb';
spec: ' outipb iiii';
fullSpec: 'outipb ichn, ivalue, imin, imax';
doc: 'Sends MIDI pitch-bend messages at i-rate.';
html: 'outipb.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'outipc';
spec: ' outipc iiii';
fullSpec: 'outipc ichn, iprog, imin, imax';
doc: 'Sends MIDI program change messages at i-rate';
html: 'outipc.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'outkat';
spec: ' outkat kkkk';
fullSpec: 'outkat kchn, kvalue, kmin, kmax';
doc: 'Sends MIDI aftertouch messages at k-rate.';
html: 'outkat.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'outkc';
spec: ' outkc kkkkk';
fullSpec: 'outkc kchn, knum, kvalue, kmin, kmax';
doc: 'Sends MIDI controller messages at k-rate.';
html: 'outkc.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'outkc14';
spec: ' outkc14 kkkkkk';
fullSpec: 'outkc14 kchn, kmsb, klsb, kvalue, kmin, kmax';
doc: 'Sends 14-bit MIDI controller output at k-rate.';
html: 'outkc14.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'outkpat';
spec: ' outkpat kkkkk';
fullSpec: 'outkpat kchn, knotenum, kvalue, kmin, kmax';
doc: 'Sends polyphonic MIDI aftertouch messages at k-rate.';
html: 'outkpat.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'outkpb';
spec: ' outkpb kkkk';
fullSpec: 'outkpb kchn, kvalue, kmin, kmax';
doc: 'Sends MIDI pitch-bend messages at k-rate.';
html: 'outkpb.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'outkpc';
spec: ' outkpc kkkk';
fullSpec: 'outkpc kchn, kprog, kmin, kmax';
doc: 'Sends MIDI program change messages at k-rate.';
html: 'outkpc.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'outo';
spec: ' outo aaaaaaaa';
fullSpec: 'outo asig1, asig2, asig3, asig4, asig5, asig6, asig7, asig8';
doc: 'Writes 8-channel audio data to an external device or stream.';
html: 'outo.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'outq';
spec: ' outq aaaa';
fullSpec: 'outq asig1, asig2, asig3, asig4';
doc: 'Writes 4-channel audio data to an external device or stream.';
html: 'outq.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'outq1';
spec: ' outq1 a';
fullSpec: 'outq1 asig';
doc: 'Writes samples to quad channel 1 of an external device or stream.';
html: 'outq1.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'outq2';
spec: ' outq2 a';
fullSpec: 'outq2 asig';
doc: 'Writes samples to quad channel 2 of an external device or stream.';
html: 'outq2.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'outq3';
spec: ' outq3 a';
fullSpec: 'outq3 asig';
doc: 'Writes samples to quad channel 3 of an external device or stream.';
html: 'outq3.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'outq4';
spec: ' outq4 a';
fullSpec: 'outq4 asig';
doc: 'Writes samples to quad channel 4 of an external device or stream.';
html: 'outq4.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'outs';
spec: ' outs aa';
fullSpec: 'outs asig1, asig2';
doc: 'Writes stereo audio data to an external device or stream.';
html: 'outs.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'outs1';
spec: ' outs1 a';
fullSpec: 'outs1 asig';
doc: 'Writes samples to stereo channel 1 of an external device or stream.';
html: 'outs1.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'outs2';
spec: ' outs2 a';
fullSpec: 'outs2 asig';
doc: 'Writes samples to stereo channel 2 of an external device or stream.';
html: 'outs2.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'outvalue';
spec: ' outvalue "k';
fullSpec: 'outvalue "channel name", kvalue';
doc: 'Sends a k-rate signal to a user-defined channel.';
html: 'outvalue.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'outx';
spec: ' outx aaaaaaaaaaaaaaaa';
fullSpec: 'outx asig1, asig2, asig3, asig4, asig5, asig6, asig7, asig8, asig9, asig10, asig11, asig12, asig13, asig14, asig15, asig16';
doc: 'Writes 16-channel audio data to an external device or stream.';
html: 'outx.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'outz';
spec: ' outz k';
fullSpec: 'outz ksig1';
doc: 'Writes multi-channel audio data from a ZAK array to an external device or stream.';
html: 'outz.html')!

''!CsoundOpcode functions add: ('p' -> 'p.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'pan';
spec: 'aaaa pan akkiii';
fullSpec: 'a1, a2, a3, a4 pan asig, kx, ky, ifn [, imode] [, ioffset]';
doc: 'Distribute an audio signal amongst four channels with localization control.';
html: 'pan.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'pareq';
spec: 'a pareq akkki';
fullSpec: 'ar pareq asig, kc, kv, kq [, imode]';
doc: 'Implementation of Zoelzers parametric equalizer filters, with some modifications by the author.';
html: 'pareq.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'pcauchy';
spec: 'x pcauchy k';
fullSpec: 'ar pcauchy kalpha
ir pcauchy kalpha
kr pcauchy kalpha';
doc: 'Cauchy distribution random number generator (positive values only). This is an x-class noise generator.';
html: 'pcauchy.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'pchbend';
spec: 'x pchbend ii';
fullSpec: 'ibend pchbend [imin] [, imax]
kbend pchbend [imin] [, imax]';
doc: 'Get the current pitch-bend value for this channel.';
html: 'pchbend.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'pchmidi';
spec: 'i pchmidi ';
fullSpec: 'ipch pchmidi';
doc: 'Get the note number of the current MIDI event, expressed in pitch-class units.';
html: 'pchmidi.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'pchmidib';
spec: 'x pchmidib i';
fullSpec: 'ipch pchmidib [irange]
kpch pchmidib [irange]';
doc: 'Get the note number of the current MIDI event and modify it by the current pitch-bend value, express it in pitch-class units.';
html: 'pchmidib.html')!

''!CsoundOpcode functions add: ('pchoct' -> 'pchoct.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'peak';
spec: 'k peak x';
fullSpec: 'kr peak asig
kr peak ksig';
doc: 'These opcodes maintain the output k-rate variable as the peak absolute level so far received.';
html: 'peak.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'pgmassign';
spec: ' pgmassign iX';
fullSpec: 'pgmassign ipgm, inst
pgmassign ipgm, "insname"';
doc: 'Assigns an instrument number to a specified (or all) MIDI program(s).';
html: 'pgmassign.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'phaser1';
spec: 'a phaser1 akkki';
fullSpec: 'ar phaser1 asig, kfreq, kord, kfeedback [, iskip]';
doc: 'An implementation of iord number of first-order allpass filters in series.';
html: 'phaser1.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'phaser2';
spec: 'a phaser2 akkkkkk';
fullSpec: 'ar phaser2 asig, kfreq, kq, kord, kmode, ksep, kfeedback';
doc: 'An implementation of iord number of second-order allpass filters in series.';
html: 'phaser2.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'phasor';
spec: 'x phasor xi';
fullSpec: 'ar phasor xcps [, iphs]
kr phasor kcps [, iphs]';
doc: 'Produce a normalized moving phase value.';
html: 'phasor.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'phasorbnk';
spec: 'x phasorbnk xkii';
fullSpec: 'ar phasorbnk xcps, kndx, icnt [, iphs]
kr phasorbnk kcps, kndx, icnt [, iphs]';
doc: 'Produce an arbitrary number of normalized moving phase values, accessable by an index.';
html: 'phasorbnk.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'pinkish';
spec: 'a pinkish xiiii';
fullSpec: 'ar pinkish xin [, imethod] [, inumbands] [, iseed] [, iskip]';
doc: 'Generates approximate pink noise (-3dB/oct response) by one of two different methods:      
a multirate noise generator after Moore, coded by Martin Gardner
a filter bank designed by Paul Kellet';
html: 'pinkish.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'pitch';
spec: 'kk pitch aiiiiiiiiiiii';
fullSpec: 'koct, kamp pitch asig, iupdte, ilo, ihi, idbthresh [, ifrqs] [, iconf] [, istrt] [, iocts] [, iq] [, inptls] [, irolloff] [, iskip]';
doc: 'Using the same techniques as spectrum and specptrk, pitch tracks the pitch of the signal in octave point decimal form, and amplitude in dB.';
html: 'pitch.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'pitchamdf';
spec: 'kk pitchamdf aiiiiiii';
fullSpec: 'kcps, krms pitchamdf asig, imincps, imaxcps [, icps] [, imedi] [, idowns] [, iexcps] [, irmsmedi]';
doc: 'Follows the pitch of a signal based on the AMDF method (Average Magnitude Difference Function). Outputs pitch and amplitude tracking signals. The method is quite fast and should run in realtime. This technique usually works best for monophonic signals.';
html: 'pitchamdf.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'planet';
spec: 'aaa planet kkkiiiiiiii';
fullSpec: 'ax, ay, az planet kmass1, kmass2, ksep, ix, iy, iz, ivx, ivy, ivz, idelta [, ifriction]';
doc: 'planet simulates a planet orbiting in a binary star system. The outputs are the x, y and z coordinates of the orbiting planet. It is possible for the planet to achieve escape velocity by a close encounter with a star. This makes this system somewhat unstable.';
html: 'planet.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'pluck';
spec: 'a pluck kkiiiii';
fullSpec: 'ar pluck kamp, kcps, icps, ifn, imeth [, iparm1] [, iparm2]';
doc: 'Audio output is a naturally decaying plucked string or drum sound based on the Karplus-Strong algorithms.';
html: 'pluck.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'poisson';
spec: 'x poisson k';
fullSpec: 'ar poisson klambda
ir poisson klambda
kr poisson klambda';
doc: 'Poisson distribution random number generator (positive values only). This is an x-class noise generator.';
html: 'poisson.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'polyaft';
spec: 'x polyaft iii';
fullSpec: 'ir polyaft inote [, ilow] [, ihigh]
kr polyaft inote [, ilow] [, ihigh]';
doc: 'polyaft returns the polyphonic pressure of the selected note number, optionally mapped to an user-specified range.';
html: 'polyaft.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'port';
spec: 'k port kii';
fullSpec: 'kr port ksig, ihtim [, isig]';
doc: 'Applies portamento to a step-valued control signal.';
html: 'port.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'portk';
spec: 'k portk kki';
fullSpec: 'kr portk ksig, khtim [, isig]';
doc: 'Applies portamento to a step-valued control signal.';
html: 'portk.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'poscil';
spec: 'x poscil xxii';
fullSpec: 'ar poscil aamp, acps, ifn [, iphs]
ar poscil aamp, kcps, ifn [, iphs]
ar poscil kamp, acps, ifn [, iphs]
ar poscil kamp, kcps, ifn [, iphs]
ir poscil kamp, kcps, ifn [, iphs]
kr poscil kamp, kcps, ifn [, iphs]';
doc: 'High precision oscillator.';
html: 'poscil.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'poscil3';
spec: 'x poscil3 kkii';
fullSpec: 'ar poscil3 kamp, kcps, ifn [, iphs]
kr poscil3 kamp, kcps, ifn [, iphs]';
doc: 'High precision oscillator with cubic interpolation.';
html: 'poscil3.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'pow';
spec: 'x pow xxi';
fullSpec: 'ar pow aarg, kpow [, inorm]
ir pow iarg, ipow [, inorm]
kr pow karg, kpow [, inorm]';
doc: 'Computes xarg to the power of kpow (or ipow) and scales the result by inorm.';
html: 'pow.html')!

''!CsoundOpcode functions add: ('powoftwo' -> 'powoftwo.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'prealloc';
spec: ' prealloc Xi';
fullSpec: 'prealloc insnum, icount
prealloc "insname", icount';
doc: 'Creates space for instruments but does not run them.';
html: 'prealloc.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'print';
spec: ' print iii';
fullSpec: 'print iarg [, iarg1] [, iarg2] [...]';
doc: 'These units will print orchestra init-values, or produce graphic display of orchestra control signals and audio signals. Uses X11 windows if enabled, else (or if -g flag is set) displays are approximated in ASCII characters.';
html: 'print.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'printk';
spec: ' printk iki';
fullSpec: 'printk itime, kval [, ispace]';
doc: 'Prints one k-rate value at specified intervals.';
html: 'printk.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'printk2';
spec: ' printk2 ki';
fullSpec: 'printk2 kvar [, inumspaces]';
doc: 'Prints a new value every time a control variable changes.';
html: 'printk2.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'printks';
spec: ' printks "ikk';
fullSpec: 'printks "string", itime [, kval1] [, kval2] [...]';
doc: 'Prints at k-rate using a printf() style syntax.';
html: 'printks.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'prints';
spec: ' prints "kk';
fullSpec: 'prints "string" [, kval1] [, kval2] [...]';
doc: 'Prints at init-time using a printf() style syntax.';
html: 'prints.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'product';
spec: 'a product aaa';
fullSpec: 'ar product asig1, asig2 [, asig3] [...]';
doc: 'Multiplies any number of a-rate signals.';
html: 'product.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'pset';
spec: ' pset ii';
fullSpec: 'pset icon1 [, icon2] [...]';
doc: 'Defines and initializes numeric arrays at orchestra load time.';
html: 'pset.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'pvadd';
spec: 'a pvadd kkiiiiiiii';
fullSpec: 'ar pvadd ktimpnt, kfmod, ifilcod, ifn, ibins [, ibinoffset] [, ibinincr] [, iextractmode] [, ifreqlim] [, igatefn]';
doc: 'pvadd reads from a pvoc file and uses the data to perform additive synthesis using an internal array of interpolating oscillators. The user supplies the wave table (usually one period of a sine wave), and can choose which analysis bins will be used in the re-synthesis.';
html: 'pvadd.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'pvbufread';
spec: ' pvbufread ki';
fullSpec: 'pvbufread ktimpnt, ifile';
doc: 'pvbufread reads from a pvoc file and makes the retrieved data available to any following pvinterp and pvcross units that appear in an instrument before a subsequent pvbufread (just as lpread and lpreson work together). The data is passed internally and the unit has no output of its own. ';
html: 'pvbufread.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'pvcross';
spec: 'a pvcross kkikki';
fullSpec: 'ar pvcross ktimpnt, kfmod, ifile, kampscale1, kampscale2 [, ispecwp]';
doc: 'pvcross applies the amplitudes from one phase vocoder analysis file to the data from a second file and then performs the resynthesis. The data is passed, as described above, from a previously called pvbufread unit. The two k-rate amplitude arguments are used to scale the amplitudes of each files separately before they are added together and used in the resynthesis (see below for further explanation). The frequencies of the first file are not used at all in this process. This unit simply allows for cross-synthesis through the application of the amplitudes of the spectra of one signal to the frequencies of a second signal. Unlike pvinterp, pvcross does allow for the use of the ispecwp as in pvoc and vpvoc.';
html: 'pvcross.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'pvinterp';
spec: 'a pvinterp kkikkkkkk';
fullSpec: 'ar pvinterp ktimpnt, kfmod, ifile, kfreqscale1, kfreqscale2, kampscale1, kampscale2, kfreqinterp, kampinterp';
doc: 'pvinterp interpolates between the amplitudes and frequencies, on a bin by bin basis, of two phase vocoder analysis files (one from a previously called pvbufread unit and the other from within its own argument list), allowing for user defined transitions between analyzed sounds. It also allows for general scaling of the amplitudes and frequencies of each file separately before the interpolated values are calculated and sent to the resynthesis routines. The kfmod argument in pvinterp performs its frequency scaling on the frequency values after their derivation from the separate scaling and subsequent interpolation is performed so that this acts as an overall scaling value of the new frequency components.';
html: 'pvinterp.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'pvoc';
spec: 'a pvoc kkiiiii';
fullSpec: 'ar pvoc ktimpnt, kfmod, ifilcod [, ispecwp] [, iextractmode] [, ifreqlim] [, igatefn]';
doc: 'Implements signal reconstruction using an fft-based phase vocoder.';
html: 'pvoc.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'pvread';
spec: 'kk pvread kii';
fullSpec: 'kfreq, kamp pvread ktimpnt, ifile, ibin';
doc: 'pvread reads from a pvoc file and returns the frequency and amplitude from a single analysis channel or bin. The returned values can be used anywhere else in the Csound instrument. For example, one can use them as arguments to an oscillator to synthesize a single component from an analyzed signal or a bank of pvreads can be used to resynthesize the analyzed sound using additive synthesis by passing the frequency and magnitude values to a bank of oscillators.';
html: 'pvread.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'pvsadsyn';
spec: 'a pvsadsyn fikiii';
fullSpec: 'ar pvsadsyn fsrc, inoscs, kfmod [, ibinoffset] [, ibinincr] [, iinit]';
doc: 'Resynthesize using a fast oscillator-bank.';
html: 'pvsadsyn.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'pvsanal';
spec: 'f pvsanal aiiiiii';
fullSpec: 'fsig pvsanal ain, ifftsize, ioverlap, iwinsize, iwintype [, iformat] [, iinit]';
doc: 'Generate an fsig from a mono audio source ain, using phase vocoder overlap-add analysis.';
html: 'pvsanal.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'pvscross';
spec: 'f pvscross ffkk';
fullSpec: 'fsig pvscross fsrc, fdest, kamp1, kamp2';
doc: 'Performs cross-synthesis between two source fsigs.';
html: 'pvscross.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'pvsfread';
spec: 'f pvsfread kii';
fullSpec: 'fsig pvsfread ktimpt, ifn [, ichan]';
doc: 'Create an fsig stream by reading a selected channel from a PVOC-EX analysis file loaded into memory, with frame interpolation. Only format 0 files (amplitude+frequency) are currently supported. The operation of this opcode mirrors that of pvoc, but outputs an fsig instead of a resynthesized signal.';
html: 'pvsfread.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'pvsftr';
spec: ' pvsftr fii';
fullSpec: 'pvsftr fsrc, ifna [, ifnf]';
doc: 'Reads amplitude and/or frequency data from function tables.';
html: 'pvsftr.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'pvsftw';
spec: 'k pvsftw fii';
fullSpec: 'kflag pvsftw fsrc, ifna [, ifnf]';
doc: 'Writes amplitude and/or frequency data to function tables.';
html: 'pvsftw.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'pvsinfo';
spec: 'iiii pvsinfo f';
fullSpec: 'ioverlap, inumbins, iwinsize, iformat pvsinfo fsrc';
doc: 'Get format information about fsrc, whether created by an opcode such as pvsanal, or obtained from a PVOCEX file by pvsfread. This information is available at init time, and can be used to set parameters for other pvs opcodes, and in particular for creating function tables (e.g. for pvsftw), or setting the number of oscillators for pvsadsyn.';
html: 'pvsinfo.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'pvsmaska';
spec: 'f pvsmaska fik';
fullSpec: 'fsig pvsmaska fsrc, ifn, kdepth';
doc: 'Modify amplitudes of fsrc using  function table, with dynamic scaling.';
html: 'pvsmaska.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'pvsynth';
spec: 'a pvsynth fi';
fullSpec: 'ar pvsynth fsrc, [iinit]';
doc: 'Resynthesise using a FFT overlap-add.';
html: 'pvsynth.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'rand';
spec: 'x rand xiii';
fullSpec: 'ar rand xamp [, iseed] [, isel] [, ibase]
kr rand xamp [, iseed] [, isel] [, ibase]';
doc: 'Output is a controlled random number series between -amp and +amp';
html: 'rand.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'randh';
spec: 'x randh xxiii';
fullSpec: 'ar randh xamp, xcps [, iseed] [, isize] [, ioffset]
kr randh kamp, kcps [, iseed] [, isize] [, ioffset]';
doc: 'Generates random numbers and holds them for a period of time.';
html: 'randh.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'randi';
spec: 'x randi xxiii';
fullSpec: 'ar randi xamp, xcps [, iseed] [, isize] [, ioffset]
kr randi kamp, kcps [, iseed] [, isize] [, ioffset]';
doc: 'Generates a controlled random number series with interpolation between each new number.';
html: 'randi.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'random';
spec: 'x random xx';
fullSpec: 'ar random kmin, kmax
ir random imin, imax
kr random kmin, kmax';
doc: 'Generates is a controlled pseudo-random number series between min and max values.';
html: 'random.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'randomh';
spec: 'x randomh kkx';
fullSpec: 'ar randomh kmin, kmax, acps
kr randomh kmin, kmax, kcps';
doc: 'Generates random numbers with a user-defined limit and holds them for a period of time. ';
html: 'randomh.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'randomi';
spec: 'x randomi kkx';
fullSpec: 'ar randomi kmin, kmax, acps
kr randomi kmin, kmax, kcps';
doc: 'Generates a user-controlled random number series with interpolation between each new number.';
html: 'randomi.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'readclock';
spec: 'i readclock i';
fullSpec: 'ir readclock inum';
doc: 'Reads the value of an internal clock.';
html: 'readclock.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'readk';
spec: 'k readk iiii';
fullSpec: 'kr readk ifilname, iformat, ipol [, interp]';
doc: 'Periodically reads an orchestra control-signal value to a named external file in a specific format.';
html: 'readk.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'readk2';
spec: 'kk readk2 iiii';
fullSpec: 'kr1, kr2 readk2 ifilname, iformat, ipol [, interp]';
doc: 'Periodically reads two orchestra control-signal values from an external file.';
html: 'readk2.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'readk3';
spec: 'kkk readk3 iiii';
fullSpec: 'kr1, kr2, kr3 readk3 ifilname, iformat, ipol [, interp]';
doc: 'Periodically reads three orchestra control-signal values from an external file.';
html: 'readk3.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'readk4';
spec: 'kkkk readk4 iiii';
fullSpec: 'kr1, kr2, kr3, kr4 readk4 ifilname, iformat, ipol [, interp]';
doc: 'Periodically reads four orchestra control-signal values from an external file.';
html: 'readk4.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'reinit';
spec: ' reinit l';
fullSpec: 'reinit label';
doc: 'Suspends a performance while a special initialization pass is executed.';
html: 'reinit.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'release';
spec: 'k release ';
fullSpec: 'kflag release';
doc: 'Indicates whether a note is in its "release" stage.';
html: 'release.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'repluck';
spec: 'a repluck ikikka';
fullSpec: 'ar repluck iplk, kamp, icps, kpick, krefl, axcite';
doc: 'repluck is an implementation of the physical model of the plucked string. A user can control the pluck point, the pickup point, the filter, and an additional audio signal, axcite. axcite is used to excite the string. Based on the Karplus-Strong algorithm.';
html: 'repluck.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'reson';
spec: 'a reson akkii';
fullSpec: 'ar reson asig, kcf, kbw [, iscl] [, iskip]';
doc: 'A second-order resonant filter.';
html: 'reson.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'resonk';
spec: 'k resonk kkkii';
fullSpec: 'kr resonk ksig, kcf, kbw [, iscl] [, iskip]';
doc: 'A second-order resonant filter.';
html: 'resonk.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'resonr';
spec: 'a resonr akkii';
fullSpec: 'ar resonr asig, kcf, kbw [, iscl] [, iskip]';
doc: 'Implementations of a second-order, two-pole two-zero bandpass filter with variable frequency response.';
html: 'resonr.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'resonx';
spec: 'a resonx akkiii';
fullSpec: 'ar resonx asig, kcf, kbw [, inumlayer] [, iscl] [, iskip]';
doc: 'resonx is equivalent to a filters consisting of more layers of reson with the same arguments, serially connected. Using a stack of a larger number of filters allows a sharper cutoff. They are faster than using a larger number instances in a Csound orchestra of the old opcodes, because only one initialization and k- cycle are needed at time and the audio loop falls entirely inside the cache memory of processor.';
html: 'resonx.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'resony';
spec: 'a resony akkikiii';
fullSpec: 'ar resony asig, kbf, kbw, inum, ksep [, isepmode] [, iscl] [, iskip]';
doc: 'A bank of second-order bandpass filters, connected in parallel.';
html: 'resony.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'resonz';
spec: 'a resonz akkii';
fullSpec: 'ar resonz asig, kcf, kbw [, iscl] [, iskip]';
doc: 'Implementations of a second-order, two-pole two-zero bandpass filter with variable frequency response.';
html: 'resonz.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'reverb';
spec: 'a reverb aki';
fullSpec: 'ar reverb asig, krvt [, iskip]';
doc: 'Reverberates an input signal with a "natural room" frequency response.';
html: 'reverb.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'reverb2';
spec: 'a reverb2 akkiiiii';
fullSpec: 'ar reverb2 asig, ktime, khdif [, iskip] [,inumCombs] [, ifnCombs] [, inumAlpas] [, ifnAlpas]';
doc: 'Same as the nreverb opcode.';
html: 'reverb2.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'rezzy';
spec: 'a rezzy axxi';
fullSpec: 'ar rezzy asig, xfco, xres [, imode]';
doc: 'A resonant low-pass filter.';
html: 'rezzy.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'rigoto';
spec: ' rigoto l';
fullSpec: 'rigoto label';
doc: 'Similar to igoto, but effective only during a reinit pass (i.e., no-op at standard i-time). This statement is useful for bypassing units that are not to be reinitialized.';
html: 'rigoto.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'rireturn';
spec: ' rireturn ';
fullSpec: 'rireturn';
doc: 'Terminates a reinit pass (i.e., no-op at standard i-time). This statement, or an endin, will cause normal performance to be resumed.';
html: 'rireturn.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'rms';
spec: 'k rms aii';
fullSpec: 'kr rms asig [, ihp] [, iskip]';
doc: 'Determines the root-mean-square amplitude of an audio signal.';
html: 'rms.html')!

''!CsoundOpcode functions add: ('rnd' -> 'rnd.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'rnd31';
spec: 'x rnd31 xxi';
fullSpec: 'ax rnd31 kscl, krpow [, iseed]
ix rnd31 iscl, irpow [, iseed]
kx rnd31 kscl, krpow [, iseed]';
doc: '31-bit bipolar random opcodes with controllable distribution. These units are portable, i.e. using the same seed value will generate the same random sequence on all systems. The distribution of generated random numbers can be varied at k-rate.';
html: 'rnd31.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'rspline';
spec: 'x rspline xxkk';
fullSpec: 'ar rspline xrangeMin, xrangeMax, kcpsMin, kcpsMax
kr rspline krangeMin, krangeMax, kcpsMin, kcpsMax';
doc: 'Generate random spline curves.';
html: 'rspline.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'rtclock';
spec: 'x rtclock ';
fullSpec: 'ir rtclock
kr rtclock';
doc: 'Read the real-time clock from the operating system.';
html: 'rtclock.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 's16b14';
spec: 'xx s16b14 iiiiiiiiiiiii';
fullSpec: 'i1,...,i16 s16b14 ichan, ictlno_msb1, ictlno_lsb1, imin1, imax1, initvalue1, ifn1,..., ictlno_msb16, ictlno_lsb16, imin16, imax16, initvalue16, ifn16
k1,...,k16 s16b14 ichan, ictlno_msb1, ictlno_lsb1, imin1, imax1, initvalue1, ifn1,..., ictlno_msb16, ictlno_lsb16, imin16, imax16, initvalue16, ifn16';
doc: 'Creates a bank of 16 different 14-bit MIDI control message numbers.';
html: 's16b14.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 's32b14';
spec: 'xx s32b14 iiiiiiiiiiiii';
fullSpec: 'i1,...,i32 s32b14 ichan, ictlno_msb1, ictlno_lsb1, imin1, imax1, initvalue1, ifn1,..., ictlno_msb32, ictlno_lsb32, imin32, imax32, initvalue32, ifn32
k1,...,k32 s32b14 ichan, ictlno_msb1, ictlno_lsb1, imin1, imax1, initvalue1, ifn1,..., ictlno_msb32, ictlno_lsb32, imin32, imax32, initvalue32, ifn32';
doc: 'Creates a bank of 32 different 14-bit MIDI control message numbers.';
html: 's32b14.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'samphold';
spec: 'x samphold xxii';
fullSpec: 'ar samphold asig, agate [, ival] [, ivstor]
kr samphold ksig, kgate [, ival] [, ivstor]';
doc: 'Performs a sample-and-hold operation on its input.';
html: 'samphold.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'sandpaper';
spec: 'a sandpaper iiiii';
fullSpec: 'ar sandpaper iamp, idettack [, inum] [, idamp] [, imaxshake]';
doc: 'sandpaper is a semi-physical model of a sandpaper sound. It is one of the PhISEM percussion opcodes. PhISEM (Physically Informed Stochastic Event Modeling) is an algorithmic approach for simulating collisions of multiple independent sound producing objects.';
html: 'sandpaper.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'scanhammer';
spec: ' scanhammer iiii';
fullSpec: 'scanhammer isrc, idst, ipos, imult';
doc: 'This is is a variant of tablecopy, copying from one table to another, starting at ipos, and with a gain control. The number of points copied is determined by the length of the source. Other points are not changed. This opcode can be used to "hit" a string in the scanned synthesis code.';
html: 'scanhammer.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'scans';
spec: 'a scans kkiii';
fullSpec: 'ar scans kamp, kfreq, ifn, id [, iorder]';
doc: 'Generate audio output using scanned synthesis.';
html: 'scans.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'scantable';
spec: 'a scantable kkiiiii';
fullSpec: 'aout scantable kamp, kpch, ipos, imass, istiff, idamp, ivel';
doc: 'A simpler scanned synthesis implementation. This is an implementation of a circular string scanned using external tables. This opcode will allow direct modification and reading of values with the table opcodes.';
html: 'scantable.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'scanu';
spec: ' scanu iiiiiiikkkkiikkaii';
fullSpec: 'scanu init, irate, ifnvel, ifnmass, ifnstif, ifncentr, ifndamp, kmass, kstif, kcentr, kdamp, ileft, iright, kpos, kstrngth, ain, idisp, id';
doc: 'Compute the waveform and the wavetable for use in scanned synthesis.';
html: 'scanu.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'schedkwhen';
spec: ' schedkwhen kkkxkkii';
fullSpec: 'schedkwhen ktrigger, kmintim, kmaxnum, kinsnum, kwhen, kdur [, ip4] [, ip5] [...]
schedkwhen ktrigger, kmintim, kmaxnum, "insname", kwhen, kdur [, ip4] [, ip5] [...]';
doc: 'Adds a new score event generated by a k-rate trigger.';
html: 'schedkwhen.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'schedkwhennamed';
spec: ' schedkwhennamed kkk"kkii';
fullSpec: 'schedkwhennamed ktrigger, kmintim, kmaxnum, "name", kwhen, kdur [, ip4] [, ip5] [...]';
doc: 'Similar to schedkwhen but uses a named instrument at init-time.';
html: 'schedkwhennamed.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'schedule';
spec: ' schedule Xiiii';
fullSpec: 'schedule insnum, iwhen, idur [, ip4] [, ip5] [...]
schedule "insname", iwhen, idur [, ip4] [, ip5] [...]';
doc: 'Adds a new score event.';
html: 'schedule.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'schedwhen';
spec: ' schedwhen kxkkii';
fullSpec: 'schedwhen ktrigger, kinsnum, kwhen, kdur [, ip4] [, ip5] [...]
schedwhen ktrigger, "insname", kwhen, kdur [, ip4] [, ip5] [...]';
doc: 'Adds a new score event.';
html: 'schedwhen.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'seed';
spec: ' seed i';
fullSpec: 'seed ival';
doc: 'Sets the global seed value for all x-class noise generators, as well as other opcodes that use a random call, such as grain. rand, randi, randh, rnd(x), and birnd(x) are not affected by seed.';
html: 'seed.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'sekere';
spec: 'a sekere iiiii';
fullSpec: 'ar sekere iamp, idettack [, inum] [, idamp] [, imaxshake]';
doc: 'sekere is a semi-physical model of a sekere sound. It is one of the PhISEM percussion opcodes. PhISEM (Physically Informed Stochastic Event Modeling) is an algorithmic approach for simulating collisions of multiple independent sound producing objects.';
html: 'sekere.html')!

''!CsoundOpcode functions add: ('semitone' -> 'semitone.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'sense';
spec: 'k sense ';
fullSpec: 'kr sense';
doc: 'Same as the sensekey opcode.';
html: 'sense.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'sensekey';
spec: 'k sensekey ';
fullSpec: 'kr sensekey';
doc: 'Returns the ASCII code of a key that has been pressed, or -1 if no key has been pressed.';
html: 'sensekey.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'seqtime';
spec: 'k seqtime kkkkk';
fullSpec: 'ktrig_out seqtime ktime_unit, kstart, kloop, kinitndx, kfn_times';
doc: 'Generates a trigger signal according to the values stored in a table.';
html: 'seqtime.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'setksmps';
spec: ' setksmps i';
fullSpec: 'setksmps iksmps';
doc: 'Sets the local ksmps value in a user-defined opcode block.';
html: 'setksmps.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'sfilist';
spec: ' sfilist i';
fullSpec: 'sfilist ifilhandle';
doc: 'Prints a list of all instruments of a previously loaded SoundFont2 (SF2) sample file. These opcodes allow management the sample-structure of SF2 files. In order to understand the usage of these opcodes, the user must have some knowledge of the SF2 format, so a brief description of this format can be found in the SoundFont2 File Format Appendix.';
html: 'sfilist.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'sfinstr';
spec: 'aa sfinstr iixxiiii';
fullSpec: 'ar1, ar2 sfinstr ivel, inotenum, xamp, xfreq, instrnum, ifilhandle [, iflag] [, ioffset]';
doc: 'Plays a SoundFont2 (SF2) sample instrument, generating a stereo sound. These opcodes allow management the sample-structure of SF2 files. In order to understand the usage of these opcodes, the user must have some knowledge of the SF2 format, so a brief description of this format can be found in the SoundFont2 File Format Appendix.';
html: 'sfinstr.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'sfinstr3';
spec: 'aa sfinstr3 iixxiiii';
fullSpec: 'ar1, ar2 sfinstr3 ivel, inotenum, xamp, xfreq, instrnum, ifilhandle [, iflag] [, ioffset]';
doc: 'Plays a SoundFont2 (SF2) sample instrument, generating a stereo sound with cubic interpolation. These opcodes allow management the sample-structure of SF2 files. In order to understand the usage of these opcodes, the user must have some knowledge of the SF2 format, so a brief description of this format can be found in the SoundFont2 File Format Appendix.';
html: 'sfinstr3.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'sfinstr3m';
spec: 'a sfinstr3m iixxiiii';
fullSpec: 'ar sfinstr3m ivel, inotenum, xamp, xfreq, instrnum, ifilhandle [, iflag] [, ioffset]';
doc: 'Plays a SoundFont2 (SF2) sample instrument, generating a mono sound with cubic interpolation. These opcodes allow management the sample-structure of SF2 files. In order to understand the usage of these opcodes, the user must have some knowledge of the SF2 format, so a brief description of this format can be found in the SoundFont2 File Format Appendix.';
html: 'sfinstr3m.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'sfinstrm';
spec: 'a sfinstrm iixxiiii';
fullSpec: 'ar sfinstrm ivel, inotenum, xamp, xfreq, instrnum, ifilhandle [, iflag] [, ioffset]';
doc: 'Plays a SoundFont2 (SF2) sample instrument, generating a mono sound. These opcodes allow management the sample-structure of SF2 files. In order to understand the usage of these opcodes, the user must have some knowledge of the SF2 format, so a brief description of this format can be found in the SoundFont2 File Format Appendix.';
html: 'sfinstrm.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'sfload';
spec: 'i sfload "';
fullSpec: 'ir sfload "filename"';
doc: 'Loads an entire SoundFont2 (SF2) sample file into memory. These opcodes allow management the sample-structure of SF2 files. In order to understand the usage of these opcodes, the user must have some knowledge of the SF2 format, so a brief description of this format can be found in the SoundFont2 File Format Appendix.';
html: 'sfload.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'sfpassign';
spec: ' sfpassign ii';
fullSpec: 'sfpassign istartindex, ifilhandle';
doc: 'Assigns all presets of a previously loaded SoundFont2 (SF2) sample file to a sequence of progressive index numbers. These opcodes allow management the sample-structure of SF2 files. In order to understand the usage of these opcodes, the user must have some knowledge of the SF2 format, so a brief description of this format can be found in the SoundFont2 File Format Appendix.';
html: 'sfpassign.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'sfplay';
spec: 'aa sfplay iixxiii';
fullSpec: 'ar1, ar2 sfplay ivel, inotenum, xamp, xfreq, ipreindex [, iflag] [, ioffset]';
doc: 'Plays a SoundFont2 (SF2) sample preset, generating a stereo sound. These opcodes allow management the sample-structure of SF2 files. In order to understand the usage of these opcodes, the user must have some knowledge of the SF2 format, so a brief description of this format can be found in the SoundFont2 File Format Appendix.';
html: 'sfplay.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'sfplay3';
spec: 'aa sfplay3 iixxiii';
fullSpec: 'ar1, ar2 sfplay3 ivel, inotenum, xamp, xfreq, ipreindex [, iflag] [, ioffset]';
doc: 'Plays a SoundFont2 (SF2) sample preset, generating a stereo sound with cubic interpolation. These opcodes allow management the sample-structure of SF2 files. In order to understand the usage of these opcodes, the user must have some knowledge of the SF2 format, so a brief description of this format can be found in the SoundFont2 File Format Appendix.';
html: 'sfplay3.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'sfplay3m';
spec: 'a sfplay3m iixxiii';
fullSpec: 'ar sfplay3m ivel, inotenum, xamp, xfreq, ipreindex [, iflag] [, ioffset]';
doc: 'Plays a SoundFont2 (SF2) sample preset, generating a mono sound with cubic interpolation. These opcodes allow management the sample-structure of SF2 files. In order to understand the usage of these opcodes, the user must have some knowledge of the SF2 format, so a brief description of this format can be found in the SoundFont2 File Format Appendix.';
html: 'sfplay3m.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'sfplaym';
spec: 'a sfplaym iixxiii';
fullSpec: 'ar sfplaym ivel, inotenum, xamp, xfreq, ipreindex [, iflag] [, ioffset]';
doc: 'Plays a SoundFont2 (SF2) sample preset, generating a mono sound. These opcodes allow management the sample-structure of SF2 files. In order to understand the usage of these opcodes, the user must have some knowledge of the SF2 format, so a brief description of this format can be found in the SoundFont2 File Format Appendix.';
html: 'sfplaym.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'sfplist';
spec: ' sfplist i';
fullSpec: 'sfplist ifilhandle';
doc: 'Prints a list of all presets of a previously loaded SoundFont2 (SF2) sample file. These opcodes allow management the sample-structure of SF2 files. In order to understand the usage of these opcodes, the user must have some knowledge of the SF2 format, so a brief description of this format can be found in the SoundFont2 File Format Appendix.';
html: 'sfplist.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'sfpreset';
spec: 'i sfpreset iiii';
fullSpec: 'ir sfpreset iprog, ibank, ifilhandle, ipreindex';
doc: 'Assigns an existing preset of a previously loaded SoundFont2 (SF2) sample file to an index number. These opcodes allow management the sample-structure of SF2 files. In order to understand the usage of these opcodes, the user must have some knowledge of the SF2 format, so a brief description of this format can be found in the SoundFont2 File Format Appendix.';
html: 'sfpreset.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'shaker';
spec: 'a shaker kkkkki';
fullSpec: 'ar shaker kamp, kfreq, kbeans, kdamp, ktimes [, idecay]';
doc: 'Audio output is a tone related to the shaking of a maraca or similar gourd instrument. The method is a physically inspired model developed from Perry Cook, but re-coded for Csound.';
html: 'shaker.html')!

''!CsoundOpcode functions add: ('sin' -> 'sin.html')!

''!CsoundOpcode functions add: ('sinh' -> 'sinh.html')!

''!CsoundOpcode functions add: ('sininv' -> 'sininv.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'sleighbells';
spec: 'a sleighbells kiiiiiii';
fullSpec: 'ar sleighbells kamp, idettack [, inum] [, idamp] [, imaxshake] [, ifreq] [, ifreq1] [, ifreq2]';
doc: 'sleighbells is a semi-physical model of a sleighbell sound. It is one of the PhISEM percussion opcodes. PhISEM (Physically Informed Stochastic Event Modeling) is an algorithmic approach for simulating collisions of multiple independent sound producing objects.';
html: 'sleighbells.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'slider16';
spec: 'xx slider16 iiiiiiiiiii';
fullSpec: 'i1,...,i16 slider16 ichan, ictlnum1, imin1, imax1, init1, ifn1,..., ictlnum16, imin16, imax16, init16, ifn16
k1,...,k16 slider16 ichan, ictlnum1, imin1, imax1, init1, ifn1,..., ictlnum16, imin16, imax16, init16, ifn16';
doc: 'Creates a bank of 16 different MIDI control message numbers.';
html: 'slider16.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'slider16f';
spec: 'kk slider16f iiiiiiiiiiiii';
fullSpec: 'k1,...,k16 slider16f ichan, ictlnum1, imin1, imax1, init1, ifn1, icutoff1,..., ictlnum16, imin16, imax16, init16, ifn16, icutoff16';
doc: 'Creates a bank of 16 different MIDI control message numbers, filtered before output.';
html: 'slider16f.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'slider32';
spec: 'xx slider32 iiiiiiiiiii';
fullSpec: 'i1,...,i32 slider32 ichan, ictlnum1, imin1, imax1, init1, ifn1,..., ictlnum32, imin32, imax32, init32, ifn32
k1,...,k32 slider32 ichan, ictlnum1, imin1, imax1, init1, ifn1,..., ictlnum32, imin32, imax32, init32, ifn32';
doc: 'Creates a bank of 32 different MIDI control message numbers.';
html: 'slider32.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'slider32f';
spec: 'kk slider32f iiiiiiiiiiiii';
fullSpec: 'k1,...,k32 slider32f ichan, ictlnum1, imin1, imax1, init1, ifn1, icutoff1,..., ictlnum32, imin32, imax32, init32, ifn32, icutoff32';
doc: 'Creates a bank of 32 different MIDI control message numbers, filtered before output.';
html: 'slider32f.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'slider64';
spec: 'xx slider64 iiiiiiiiiii';
fullSpec: 'i1,...,i64 slider64 ichan, ictlnum1, imin1, imax1, init1, ifn1,..., ictlnum64, imin64, imax64, init64, ifn64
k1,...,k64 slider64 ichan, ictlnum1, imin1, imax1, init1, ifn1,..., ictlnum64, imin64, imax64, init64, ifn64';
doc: 'Creates a bank of 64 different MIDI control message numbers.';
html: 'slider64.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'slider64f';
spec: 'kk slider64f iiiiiiiiiiiii';
fullSpec: 'k1,...,k64 slider64f ichan, ictlnum1, imin1, imax1, init1, ifn1, icutoff1,..., ictlnum64, imin64, imax64, init64, ifn64, icutoff64';
doc: 'Creates a bank of 64 different MIDI control message numbers, filtered before output.';
html: 'slider64f.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'slider8';
spec: 'xx slider8 iiiiiiiiiii';
fullSpec: 'i1,...,i8 slider8 ichan, ictlnum1, imin1, imax1, init1, ifn1,..., ictlnum8, imin8, imax8, init8, ifn8
k1,...,k8 slider8 ichan, ictlnum1, imin1, imax1, init1, ifn1,..., ictlnum8, imin8, imax8, init8, ifn8';
doc: 'Creates a bank of 8 different MIDI control message numbers.';
html: 'slider8.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'slider8f';
spec: 'kk slider8f iiiiiiiiiiiii';
fullSpec: 'k1,...,k8 slider8f ichan, ictlnum1, imin1, imax1, init1, ifn1, icutoff1,..., ictlnum8, imin8, imax8, init8, ifn8, icutoff8';
doc: 'Creates a bank of 8 different MIDI control message numbers, filtered before output.';
html: 'slider8f.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'sndwarp';
spec: 'aa sndwarp xxxiiiiiii';
fullSpec: 'ar [, ac] sndwarp xamp, xtimewarp, xresample, ifn1, ibeg, iwsize, irandw, ioverlap, ifn2, itimemode';
doc: 'sndwarp reads sound samples from a table and applies time-stretching and/or pitch modification. Time and frequency modification are independent from one another. For example, a sound can be stretched in time while raising the pitch';
html: 'sndwarp.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'sndwarpst';
spec: 'aaaa sndwarpst xxxiiiiiii';
fullSpec: 'ar1, ar2 [,ac1] [, ac2] sndwarpst xamp, xtimewarp, xresample, ifn1, ibeg, iwsize, irandw, ioverlap, ifn2, itimemode';
doc: 'sndwarpst reads stereo sound samples from a table and applies time-stretching and/or pitch modification. Time and frequency modification are independent from one another. For example, a sound can be stretched in time while raising the pitch';
html: 'sndwarpst.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'soundin';
spec: 'a soundin iii';
fullSpec: 'ar1 soundin ifilcod [, iskptim] [, iformat]
ar1, ar2 soundin ifilcod [, iskptim] [, iformat]
ar1, ar2, ar3 soundin ifilcod [, iskptim] [, iformat]
ar1, ar2, ar3, ar4 soundin ifilcod [, iskptim] [, iformat]';
doc: 'Reads audio data from an external device or stream.';
html: 'soundin.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'soundout';
spec: ' soundout aii';
fullSpec: 'soundout  asig1, ifilcod [, iformat]';
doc: 'Writes audio output to a disk file.';
html: 'soundout.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'space';
spec: 'aaaa space aikkkk';
fullSpec: 'a1, a2, a3, a4  space asig, ifn, ktime, kreverbsend, kx, ky';
doc: 'space takes an input signal and distributes it among 4 channels using Cartesian xy coordinates to calculate the balance of the outputs. The xy coordinates can be defined in a separate text file and accessed through a Function statement in the score using Gen28, or they can be specified using the optional kx, ky arguments. The advantages to the former are:      
A graphic user interface can be used to draw and edit the trajectory through the Cartesian plane
The file format is in the form time1 X1 Y1 time2 X2 Y2 time3 X3 Y3 allowing the user to define a time-tagged trajectory';
html: 'space.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'spat3d';
spec: 'aaaa spat3d akkkiiiiii';
fullSpec: 'aW, aX, aY, aZ spat3d ain, kX, kY, kZ, idist, ift, imode, imdel, iovr [, istor]';
doc: 'This opcode positions the input sound in a 3D space, with optional simulation of room acoustics, in various output formats. spat3d allows moving the sound at k-rate (this movement is interpolated internally to eliminate "zipper noise" if sr not equal to kr).';
html: 'spat3d.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'spat3di';
spec: 'aaaa spat3di aiiiiiii';
fullSpec: 'aW, aX, aY, aZ spat3di ain, iX, iY, iZ, idist, ift, imode [, istor]';
doc: 'This opcode positions the input sound in a 3D space, with optional simulation of room acoustics, in various output formats. With spat3di, sound source position is set at i-time.';
html: 'spat3di.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'spat3dt';
spec: ' spat3dt iiiiiiiii';
fullSpec: 'spat3dt ioutft, iX, iY, iZ, idist, ift, imode, irlen [, iftnocl]';
doc: 'This opcode positions the input sound in a 3D space, with optional simulation of room acoustics, in various output formats. spat3dt can be used to render the impulse response at i-time, storing output in a function table, suitable for convolution.';
html: 'spat3dt.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'spdist';
spec: 'k spdist ikkk';
fullSpec: 'k1 spdist ifn, ktime, kx, ky';
doc: 'spdist uses the same xy data as space, also either from a text file using Gen28 or from x and y arguments given to the unit directly. The purpose of this unit is to make available the values for distance that are calculated from the xy coordinates. ';
html: 'spdist.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'specaddm';
spec: 'w specaddm wwi';
fullSpec: 'wsig specaddm wsig1, wsig2 [, imul2]';
doc: 'Perform a weighted add of two input spectra.';
html: 'specaddm.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'specdiff';
spec: 'w specdiff w';
fullSpec: 'wsig specdiff wsigin';
doc: 'Finds the positive difference values between consecutive spectral frames.';
html: 'specdiff.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'specdisp';
spec: ' specdisp wii';
fullSpec: 'specdisp wsig, iprd [, iwtflg]';
doc: 'Displays the magnitude values of the spectrum.';
html: 'specdisp.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'specfilt';
spec: 'w specfilt wi';
fullSpec: 'wsig specfilt wsigin, ifhtim';
doc: 'Filters each channel of an input spectrum.';
html: 'specfilt.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'spechist';
spec: 'w spechist w';
fullSpec: 'wsig spechist wsigin';
doc: 'Accumulates the values of successive spectral frames.';
html: 'spechist.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'specptrk';
spec: 'kk specptrk wkiiiiiiiiiii';
fullSpec: 'koct, kamp specptrk wsig, kvar, ilo, ihi, istr, idbthresh, inptls, irolloff [, iodd] [, iconfs] [, interp] [, ifprd] [, iwtflg]';
doc: 'Estimate the pitch of the most prominent complex tone in the spectrum.';
html: 'specptrk.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'specscal';
spec: 'w specscal wii';
fullSpec: 'wsig specscal wsigin, ifscale, ifthresh';
doc: 'Scales an input spectral datablock with spectral envelopes.';
html: 'specscal.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'specsum';
spec: 'k specsum wi';
fullSpec: 'ksum specsum wsig [, interp]';
doc: 'Sums the magnitudes across all channels of the spectrum.';
html: 'specsum.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'spectrum';
spec: 'w spectrum xiiiiiiii';
fullSpec: 'wsig spectrum xsig, iprd, iocts, ifrqa [, iq] [, ihann] [, idbout] [, idsprd] [, idsinrs]';
doc: 'Generate a constant-Q, exponentially-spaced DFT across all octaves of a multiply-downsampled control or audio input signal.';
html: 'spectrum.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'spsend';
spec: 'aaaa spsend ';
fullSpec: 'a1, a2, a3, a4 spsend';
doc: 'spsend depends upon the existence of a previously defined space. The output signals from spsend are derived from the values given for xy and reverb in the space and are ready to be sent to local or global reverb units (see example below).';
html: 'spsend.html')!

''!CsoundOpcode functions add: ('sqrt' -> 'sqrt.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'stix';
spec: 'a stix iiiii';
fullSpec: 'ar stix iamp, idettack [, inum] [, idamp] [, imaxshake]';
doc: 'stix is a semi-physical model of a stick sound. It is one of the PhISEM percussion opcodes. PhISEM (Physically Informed Stochastic Event Modeling) is an algorithmic approach for simulating collisions of multiple independent sound producing objects.';
html: 'stix.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'streson';
spec: 'a streson aki';
fullSpec: 'ar streson asig, kfr, ifdbgain';
doc: 'An audio signal is modified by a string resonator with variable fundamental frequency.';
html: 'streson.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'strset';
spec: ' strset ii';
fullSpec: 'strset iarg, istring';
doc: 'Allows a string to be linked with a numeric value.';
html: 'strset.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'sum';
spec: 'a sum aaa';
fullSpec: 'ar sum asig1 [, asig2] [, asig3] [...]';
doc: 'Sums any number of a-rate signals.';
html: 'sum.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'svfilter';
spec: 'aaa svfilter akki';
fullSpec: 'alow, ahigh, aband svfilter  asig, kcf, kq [, iscl]';
doc: 'Implementation of a resonant second order filter, with simultaneous lowpass, highpass and bandpass outputs.';
html: 'svfilter.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'table';
spec: 'x table xiiii';
fullSpec: 'ar table andx, ifn [, ixmode] [, ixoff] [, iwrap]
ir table indx, ifn [, ixmode] [, ixoff] [, iwrap]
kr table kndx, ifn [, ixmode] [, ixoff] [, iwrap]';
doc: 'Accesses table values by direct indexing.';
html: 'table.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'table3';
spec: 'x table3 xiiii';
fullSpec: 'ar table3 andx, ifn [, ixmode] [, ixoff] [, iwrap]
ir table3 indx, ifn [, ixmode] [, ixoff] [, iwrap]
kr table3 kndx, ifn [, ixmode] [, ixoff] [, iwrap]';
doc: 'Accesses table values by direct indexing with cubic interpolation.';
html: 'table3.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'tablecopy';
spec: ' tablecopy kk';
fullSpec: 'tablecopy kdft, ksft';
doc: 'Simple, fast table copy opcode.';
html: 'tablecopy.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'tablegpw';
spec: ' tablegpw k';
fullSpec: 'tablegpw kfn';
doc: 'Writes a tables guard point.';
html: 'tablegpw.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'tablei';
spec: 'x tablei xiiii';
fullSpec: 'ar tablei andx, ifn [, ixmode] [, ixoff] [, iwrap]
ir tablei indx, ifn [, ixmode] [, ixoff] [, iwrap]
kr tablei kndx, ifn [, ixmode] [, ixoff] [, iwrap]';
doc: 'Accesses table values by direct indexing with linear interpolation.';
html: 'tablei.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'tableicopy';
spec: ' tableicopy ii';
fullSpec: 'tableicopy idft, isft';
doc: 'Simple, fast table copy opcode.';
html: 'tableicopy.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'tableigpw';
spec: ' tableigpw i';
fullSpec: 'tableigpw ifn';
doc: 'Writes a tables guard point.';
html: 'tableigpw.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'tableikt';
spec: 'x tableikt xkiii';
fullSpec: 'ar tableikt xndx, kfn [, ixmode] [, ixoff] [, iwrap]
kr tableikt kndx, kfn [, ixmode] [, ixoff] [, iwrap]';
doc: 'k-rate control over table numbers.';
html: 'tableikt.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'tableimix';
spec: ' tableimix iiiiiiiii';
fullSpec: 'tableimix idft, idoff, ilen, is1ft, is1off, is1g, is2ft, is2off, is2g';
doc: 'Mixes two tables.';
html: 'tableimix.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'tableiw';
spec: ' tableiw iiiiii';
fullSpec: 'tableiw isig, indx, ifn [, ixmode] [, ixoff] [, iwgmode]';
doc: 'This opcode operates on existing function tables, changing their contents. tableiw is used when all inputs are init time variables or constants and you only want to run it at the initialization of the instrument. The valid combinations of variable types are shown by the first letter of the variable names.';
html: 'tableiw.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'tablekt';
spec: 'x tablekt xkiii';
fullSpec: 'ar tablekt xndx, kfn [, ixmode] [, ixoff] [, iwrap]
kr tablekt kndx, kfn [, ixmode] [, ixoff] [, iwrap]';
doc: 'k-rate control over table numbers.';
html: 'tablekt.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'tablemix';
spec: ' tablemix kkkkkkkkk';
fullSpec: 'tablemix kdft, kdoff, klen, ks1ft, ks1off, ks1g, ks2ft, ks2off, ks2g';
doc: 'Mixes two tables.';
html: 'tablemix.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'tableng';
spec: 'x tableng x';
fullSpec: 'ir tableng ifn
kr tableng kfn';
doc: 'Interrogates a function table for length.';
html: 'tableng.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'tablera';
spec: 'a tablera kkk';
fullSpec: 'ar tablera kfn, kstart, koff';
doc: 'These opcodes read and write tables in sequential locations to and from an a-rate variable. Some thought is required before using them. They have at least two major, and quite different, applications which are discussed below.';
html: 'tablera.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'tableseg';
spec: ' tableseg iiiii';
fullSpec: 'tableseg ifn1, idur1, ifn2 [, idur2] [, ifn3] [...]';
doc: 'tableseg is like linseg but interpolate between values in a stored function tables. The result is a new function table passed internally to any following vpvoc which occurs before a subsequent tableseg (much like lpread/lpreson pairs work). The uses of these are described below under vpvoc.';
html: 'tableseg.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'tablew';
spec: ' tablew xxiiii';
fullSpec: 'tablew asig, andx, ifn [, ixmode] [, ixoff] [, iwgmode]
tablew isig, indx, ifn [, ixmode] [, ixoff] [, iwgmode]
tablew ksig, kndx, ifn [, ixmode] [, ixoff] [, iwgmode]';
doc: 'This opcode operates on existing function tables, changing their contents. tablew is for writing at k- or at a-rates, with the table number being specified at init time. The valid combinations of variable types are shown by the first letter of the variable names.';
html: 'tablew.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'tablewa';
spec: 'k tablewa kak';
fullSpec: 'kstart tablewa kfn, asig, koff';
doc: 'These opcodes read and write tables in sequential locations to and from an a-rate variable. Some thought is required before using them. They have at least two major, and quite different, applications which are discussed below.';
html: 'tablewa.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'tablewkt';
spec: ' tablewkt xxkiii';
fullSpec: 'tablewkt asig, andx, kfn [, ixmode] [, ixoff] [, iwgmode]
tablewkt ksig, kndx, kfn [, ixmode] [, ixoff] [, iwgmode]';
doc: 'This opcode operates on existing function tables, changing their contents. tablewkt uses a k-rate variable for selecting the table number. The valid combinations of variable types are shown by the first letter of the variable names.';
html: 'tablewkt.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'tablexkt';
spec: 'a tablexkt xkkiiii';
fullSpec: 'ar tablexkt xndx, kfn, kwarp, iwsize [, ixmode] [, ixoff] [, iwrap]';
doc: 'Reads function tables with linear, cubic, or sinc interpolation.';
html: 'tablexkt.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'tablexseg';
spec: ' tablexseg iiiii';
fullSpec: 'tablexseg ifn1, idur1, ifn2 [, idur2] [, ifn3] [...]';
doc: 'tablexseg is like expseg but interpolate between values in a stored function tables. The result is a new function table passed internally to any following vpvoc which occurs before a subsequent tablexseg (much like lpread/lpreson pairs work). The uses of these are described below under vpvoc.';
html: 'tablexseg.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'tambourine';
spec: 'a tambourine kiiiiiii';
fullSpec: 'ar tambourine kamp, idettack [, inum] [, idamp] [, imaxshake] [, ifreq] [, ifreq1] [, ifreq2]';
doc: 'tambourine is a semi-physical model of a tambourine sound. It is one of the PhISEM percussion opcodes. PhISEM (Physically Informed Stochastic Event Modeling) is an algorithmic approach for simulating collisions of multiple independent sound producing objects.';
html: 'tambourine.html')!

''!CsoundOpcode functions add: ('tan' -> 'tan.html')!

''!CsoundOpcode functions add: ('tanh' -> 'tanh.html')!

''!CsoundOpcode functions add: ('taninv' -> 'taninv.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'taninv2';
spec: 'x taninv2 xx';
fullSpec: 'ar taninv2 ay, ax
ir taninv2 iy, ix
kr taninv2 ky, kx
      Returns the arctangent of iy/ix, ky/kx, or ay/ax. If y is zero, taninv2 returns zero regardless of the value of x. If x is zero, the return value is:      
PI/2, if y is positive.
-PI/2, if y is negative.
0, if y is 0.
    ';
doc: 'Returns the arctangent of iy/ix, ky/kx, or ay/ax.';
html: 'taninv2.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'tbvcf';
spec: 'a tbvcf axxkk';
fullSpec: 'ar tbvcf asig, xfco, xres, kdist, kasym';
doc: 'This opcode attempts to model some of the filter characteristics of a Roland TB303 voltage-controlled filter. Eulers method is used to approximate the system, rather than traditional filter methods. Cutoff frequency, Q, and distortion are all coupled. Empirical methods were used to try to unentwine,  but frequency is only approximate as a result. Future fixes for some problems with this opcode may break existing orchestras relying on this version of tbvcf.';
html: 'tbvcf.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'tempest';
spec: 'k tempest kiiiiiiiiiii';
fullSpec: 'ktemp tempest kin, iprd, imindur, imemdur, ihp, ithresh, ihtim, ixfdbak, istartempo, ifn [, idisprd] [, itweek]';
doc: 'Estimate the tempo of beat patterns in a control signal.';
html: 'tempest.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'tempo';
spec: ' tempo ki';
fullSpec: 'tempo ktempo, istartempo';
doc: 'Apply tempo control to an uninterpreted score.';
html: 'tempo.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'tempoval';
spec: 'k tempoval ';
fullSpec: 'kr tempoval';
doc: 'Reads the current value of the tempo.';
html: 'tempoval.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'tigoto';
spec: ' tigoto l';
fullSpec: 'tigoto label
      where label is in the same instrument block and is not an expression, and where R is one of the Relational operators (&#60;, =, &#60;=, ==, =) (and = for convenience, see also under Conditional Values).    ';
doc: 'Similar to igoto but effective only during an i-time pass at which a new note is being "tied" onto a previously held note. (See i Statement) It does not work when a tie has not taken place. Allows an instrument to skip initialization of units according to whether a proposed tie was in fact successful. (See also tival, delay).';
html: 'tigoto.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'timeinstk';
spec: 'k timeinstk ';
fullSpec: 'kr timeinstk
kr timeinsts';
doc: 'Read absolute time, in k-rate cycles, since the start of an instance of an instrument.';
html: 'timeinstk.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'timeinsts';
spec: 'k timeinsts ';
fullSpec: 'kr timeinsts';
doc: 'Read absolute time, in seconds, since the start of an instance of an instrument.';
html: 'timeinsts.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'timek';
spec: 'x timek ';
fullSpec: 'ir timek
kr timek';
doc: 'Read absolute time, in k-rate cycles, since the start of the performance.';
html: 'timek.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'times';
spec: 'x times ';
fullSpec: 'ir times
kr times';
doc: 'Read absolute time, in seconds, since the start of the performance.';
html: 'times.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'timout';
spec: ' timout iil';
fullSpec: 'timout istrt, idur, label
      where label is in the same instrument block and is not an expression, and where R is one of the Relational operators (&#60;, =, &#60;=, ==, =) (and = for convenience, see also under Conditional Values).    ';
doc: 'Conditional branch during p-time depending on elapsed note time. istrt and idur specify time in seconds. The branch to label will become effective at time istrt, and will remain so for just idur seconds. Note that timout can be reinitialized for multiple activation within a single note (see example under reinit).';
html: 'timout.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'tival';
spec: 'i tival ';
fullSpec: 'ir tival';
doc: '      Puts the value of the instruments internal "tie-in" flag into the named i-rate variable.';
html: 'tival.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'tlineto';
spec: 'k tlineto kkk';
fullSpec: 'kr tlineto ksig, ktime, ktrig';
doc: 'Generate glissandos starting from a control signal with a trigger.';
html: 'tlineto.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'tone';
spec: 'a tone aki';
fullSpec: 'ar tone asig, khp [, iskip]';
doc: 'A first-order recursive low-pass with variable frequency response.';
html: 'tone.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'tonek';
spec: 'k tonek kki';
fullSpec: 'kr tonek ksig, khp [, iskip]';
doc: 'A first-order recursive low-pass filter with variable frequency response.';
html: 'tonek.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'tonex';
spec: 'a tonex akii';
fullSpec: 'ar tonex  asig, khp [, inumlayer] [, iskip]';
doc: 'tonex is equivalent to a filter consisting of more layers of tone with the same arguments, serially connected. Using a stack of a larger number of filters allows a sharper cutoff. They are faster than using a larger number instances in a Csound orchestra of the old opcodes, because only one initialization and k- cycle are needed at time and the audio loop falls entirely inside the cache memory of processor.';
html: 'tonex.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'transeg';
spec: 'x transeg iiiiiii';
fullSpec: 'ar transeg ia, idur, itype, ib [, idur2] [, itype] [, ic] ...
kr transeg ia, idur, itype, ib [, idur2] [, itype] [, ic] ...';
doc: 'Constructs a user-definable envelope.';
html: 'transeg.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'trigger';
spec: 'k trigger kkk';
fullSpec: 'kout trigger ksig, kthreshold, kmode';
doc: 'Informs when a krate signal crosses a threshold.';
html: 'trigger.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'trigseq';
spec: ' trigseq kkkkkkk';
fullSpec: 'trigseq ktrig_in, kstart, kloop, kinitndx, kfn_values, kout1 [, kout2] [...]';
doc: 'Accepts a trigger signal as input and outputs a group of values.';
html: 'trigseq.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'trirand';
spec: 'x trirand k';
fullSpec: 'ar trirand krange
ir trirand krange
kr trirand krange';
doc: 'Linear distribution random number generator. This is an x-class noise generator.';
html: 'trirand.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'turnoff';
spec: ' turnoff ';
fullSpec: 'turnoff';
doc: 'Enables an instrument to turn itself off. ';
html: 'turnoff.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'turnon';
spec: ' turnon ii';
fullSpec: 'turnon insnum [, itime]';
doc: 'Activate an instrument for an indefinite time.';
html: 'turnon.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'unirand';
spec: 'x unirand k';
fullSpec: 'ar unirand krange
ir unirand krange
kr unirand krange';
doc: 'Uniform distribution random number generator (positive values only). This is an x-class noise generator.';
html: 'unirand.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'upsamp';
spec: 'a upsamp k';
fullSpec: 'ar upsamp ksig';
doc: 'Modify a signal by up-sampling.';
html: 'upsamp.html')!

''!CsoundOpcode functions add: ('urd' -> 'urd.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'valpass';
spec: 'a valpass akxiii';
fullSpec: 'ar valpass asig, krvt, xlpt, imaxlpt [, iskip] [, insmps]';
doc: 'Variably reverberates an input signal with a flat frequency response.';
html: 'valpass.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'vbap16';
spec: 'aa vbap16 aiii';
fullSpec: 'ar1, ..., ar16 vbap16 asig, iazim [, ielev] [, ispread]';
doc: 'Distributes an audio signal among 16 channels.';
html: 'vbap16.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'vbap16move';
spec: 'aa vbap16move aiiii';
fullSpec: 'ar1, ..., ar16 vbap16move asig, ispread, ifldnum, ifld1 [, ifld2] [...]';
doc: 'Distribute an audio signal among 16 channels with moving virtual sources.';
html: 'vbap16move.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'vbap4';
spec: 'aaaa vbap4 aiii';
fullSpec: 'ar1, ar2, ar3, ar4 vbap4 asig, iazim [, ielev] [, ispread]';
doc: 'Distributes an audio signal among 4 channels.';
html: 'vbap4.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'vbap4move';
spec: 'aaaa vbap4move aiiii';
fullSpec: 'ar1, ar2, ar3, ar4 vbap4move asig, ispread, ifldnum, ifld1 [, ifld2] [...]';
doc: 'Distributes an audio signal among 4 channels with moving virtual sources.';
html: 'vbap4move.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'vbap8';
spec: 'aa vbap8 aiii';
fullSpec: 'ar1, ..., ar8 vbap8 asig, iazim [, ielev] [, ispread]';
doc: 'Distributes an audio signal among 8 channels.';
html: 'vbap8.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'vbap8move';
spec: 'aa vbap8move aiiii';
fullSpec: 'ar1, ..., ar8 vbap8move asig, ispread, ifldnum, ifld1 [, ifld2] [...]';
doc: 'Distributes an audio signal among 8 channels with moving virtual sources.';
html: 'vbap8move.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'vbaplsinit';
spec: ' vbaplsinit iiiii';
fullSpec: 'vbaplsinit idim, ilsnum [, idir1] [, idir2] [...] [, idir32]';
doc: 'Configures VBAP output according to loudspeaker parameters.';
html: 'vbaplsinit.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'vbapz';
spec: ' vbapz iiaiii';
fullSpec: 'vbapz inumchnls, istartndx, asig, iazim [, ielev] [, ispread]';
doc: 'Writes a multi-channel audio signal to a ZAK array.';
html: 'vbapz.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'vbapzmove';
spec: ' vbapzmove iiaiiiii';
fullSpec: 'vbapzmove inumchnls, istartndx, asig, idur, ispread, ifldnum, ifld1, ifld2, [...]';
doc: 'Writes a multi-channel audio signal to a ZAK array with moving virtual sources.';
html: 'vbapzmove.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'vco';
spec: 'a vco xxikiiiii';
fullSpec: 'ar vco xamp, xcps, iwave, kpw [, ifn] [, imaxd] [, ileak] [, inyx] [, iphs]';
doc: 'Implementation of a band limited, analog modeled oscillator, based on integration of band limited impulses. vco can be used to simulate a variety of analog wave forms.';
html: 'vco.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'vco2';
spec: 'a vco2 kkikki';
fullSpec: 'ar vco2 kamp, kcps [, imode] [, kpw] [, kphs] [, inyx]';
doc: 'vco2 is similar to vco. But the implementation uses pre-calculated tables of band-limited waveforms (see also GEN30) rather than integrating impulses. This opcode can be faster than vco (especially if a low control-rate is used) and also allows better sound quality. Additionally, there are more waveforms and oscillator phase can be modulated at k-rate. The disadvantage is increased memory usage. For more details about vco2 tables, see also vco2init and vco2ft.';
html: 'vco2.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'vco2ft';
spec: 'k vco2ft kii';
fullSpec: 'kfn vco2ft kcps, iwave [, inyx]';
doc: 'vco2ft returns the function table number to be used for generating the specified waveform at a given frequency. This function table number can be used by any Csound opcode that generates a signal by reading function tables (like oscilikt). The tables must be calculated by vco2init before vco2ft is called and shared as Csound ftables (ibasfn).';
html: 'vco2ft.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'vco2ift';
spec: 'i vco2ift iii';
fullSpec: 'ifn vco2ift icps, iwave [, inyx]';
doc: 'vco2ift is the same as vco2ft, but works at i-time. It is suitable for use with opcodes that expect an i-rate table number (for example, oscili).';
html: 'vco2ift.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'vco2init';
spec: 'i vco2init iiiiii';
fullSpec: 'ifn vco2init iwave [, ibasfn] [, ipmul] [, iminsiz] [, imaxsiz] [, isrcft]';
doc: 'vco2init calculates tables for use by vco2 opcode. Optionally, it is also possible to access these tables as standard Csound function tables. In this case, vco2ft can be used to find the correct table number for a given oscillator frequency.';
html: 'vco2init.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'vcomb';
spec: 'a vcomb akxiii';
fullSpec: 'ar vcomb asig, krvt, xlpt, imaxlpt [, iskip] [, insmps]';
doc: 'Variably reverberates an input signal with a "colored" frequency response.';
html: 'vcomb.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'vdelay';
spec: 'a vdelay aaii';
fullSpec: 'ar vdelay asig, adel, imaxdel [, iskip]';
doc: 'This is an interpolating variable time delay, it is not very different from the existing implementation (deltapi), it is only easier to use.';
html: 'vdelay.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'vdelay3';
spec: 'a vdelay3 aaii';
fullSpec: 'ar vdelay3 asig, adel, imaxdel [, iskip]';
doc: 'vdelay3 is experimental. It is the same as vdelay except that it uses cubic interpolation. (New in Version 3.50.)';
html: 'vdelay3.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'vdelayx';
spec: 'a vdelayx aaiii';
fullSpec: 'aout vdelayx ain, adl, imd, iws [, ist]';
doc: 'A variable delay opcode with high quality interpolation.';
html: 'vdelayx.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'vdelayxq';
spec: 'aaaa vdelayxq aaaaaiii';
fullSpec: 'aout1, aout2, aout3, aout4 vdelayxq ain1, ain2, ain3, ain4, adl, imd, iws [, ist]';
doc: 'A 4-channel variable delay opcode with high quality interpolation.';
html: 'vdelayxq.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'vdelayxs';
spec: 'aa vdelayxs aaaiii';
fullSpec: 'aout1, aout2 vdelayxs ain1, ain2, adl, imd, iws [, ist]';
doc: 'A stereo variable delay opcode with high quality interpolation.';
html: 'vdelayxs.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'vdelayxw';
spec: 'a vdelayxw aaiii';
fullSpec: 'aout vdelayxw ain, adl, imd, iws [, ist]';
doc: 'Variable delay opcodes with high quality interpolation.';
html: 'vdelayxw.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'vdelayxwq';
spec: 'aaaa vdelayxwq aaaaaiii';
fullSpec: 'aout1, aout2, aout3, aout4 vdelayxwq ain1, ain2, ain3, ain4, adl, imd, iws [, ist]';
doc: 'Variable delay opcodes with high quality interpolation.';
html: 'vdelayxwq.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'vdelayxws';
spec: 'aa vdelayxws aaaiii';
fullSpec: 'aout1, aout2 vdelayxws ain1, ain2, adl, imd, iws [, ist]';
doc: 'Variable delay opcodes with high quality interpolation.';
html: 'vdelayxws.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'veloc';
spec: 'i veloc ii';
fullSpec: 'ival veloc [ilow] [, ihigh]';
doc: 'Get the velocity from a MIDI event.';
html: 'veloc.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'vibes';
spec: 'a vibes kkiiikkii';
fullSpec: 'ar vibes kamp, kfreq, ihrd, ipos, imp, kvibf, kvamp, ivibfn, idec';
doc: 'Audio output is a tone related to the striking of a metal block as found in a vibraphone. The method is a physical model developed from Perry Cook, but re-coded for Csound.';
html: 'vibes.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'vibr';
spec: 'k vibr kki';
fullSpec: 'kout vibr kAverageAmp, kAverageFreq, ifn';
doc: 'Easier-to-use user-controllable vibrato.';
html: 'vibr.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'vibrato';
spec: 'k vibrato kkkkkkkkii';
fullSpec: 'kout vibrato kAverageAmp, kAverageFreq, kRandAmountAmp, kRandAmountFreq, kAmpMinRate, kAmpMaxRate, kcpsMinRate, kcpsMaxRate, ifn [, iphs]';
doc: 'Generates a natural-sounding user-controllable vibrato.';
html: 'vibrato.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'vincr';
spec: ' vincr aa';
fullSpec: 'vincr asig, aincr';
doc: 'vincr increments an audio variable of another signal, i.e. accumulates output.';
html: 'vincr.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'vlowres';
spec: 'a vlowres akkik';
fullSpec: 'ar vlowres asig, kfco, kres, iord, ksep';
doc: 'A bank of filters in which the cutoff frequency can be separated under user control';
html: 'vlowres.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'voice';
spec: 'a voice kkkkkkii';
fullSpec: 'ar voice kamp, kfreq, kphoneme, kform, kvibf, kvamp, ifn, ivfn';
doc: 'An emulation of a human voice.';
html: 'voice.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'vpvoc';
spec: 'a vpvoc kkiii';
fullSpec: 'ar vpvoc ktimpnt, kfmod, ifile [, ispecwp] [, ifn]';
doc: 'Implements signal reconstruction using an fft-based phase vocoder and an extra envelope.';
html: 'vpvoc.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'waveset';
spec: 'a waveset aki';
fullSpec: 'ar waveset ain, krep [, ilen]';
doc: 'A simple time stretch by repeating cycles.';
html: 'waveset.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'weibull';
spec: 'x weibull kk';
fullSpec: 'ar weibull ksigma, ktau
ir weibull ksigma, ktau
kr weibull ksigma, ktau';
doc: 'Weibull distribution random number generator (positive values only). This is an x-class noise generator';
html: 'weibull.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'wgbow';
spec: 'a wgbow kkkkkkii';
fullSpec: 'ar wgbow kamp, kfreq, kpres, krat, kvibf, kvamp, ifn [, iminfreq]';
doc: 'Audio output is a tone similar to a bowed string, using a physical model developed from Perry Cook, but re-coded for Csound.';
html: 'wgbow.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'wgbowedbar';
spec: 'a wgbowedbar kkkkkiiii';
fullSpec: 'ar wgbowedbar kamp, kfreq, kpos, kbowpres, kgain [, iconst] [, itvel] [, ibowpos] [, ilow]';
doc: 'A physical model of a bowed bar, belonging to the Perry Cook family of waveguide instruments.';
html: 'wgbowedbar.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'wgbrass';
spec: 'a wgbrass kkkikkii';
fullSpec: 'ar wgbrass kamp, kfreq, ktens, iatt, kvibf, kvamp, ifn [, iminfreq]';
doc: 'Audio output is a tone related to a brass instrument, using a physical model developed from Perry Cook, but re-coded for Csound. ';
html: 'wgbrass.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'wgclar';
spec: 'a wgclar kkkiikkkii';
fullSpec: 'ar wgclar kamp, kfreq, kstiff, iatt, idetk, kngain, kvibf, kvamp, ifn [, iminfreq]';
doc: 'Audio output is a tone similar to a clarinet, using a physical model developed from Perry Cook, but re-coded for Csound.';
html: 'wgclar.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'wgflute';
spec: 'a wgflute kkkiikkkiiii';
fullSpec: 'ar wgflute kamp, kfreq, kjet, iatt, idetk, kngain, kvibf, kvamp, ifn [, iminfreq] [, ijetrf] [, iendrf]';
doc: 'Audio output is a tone similar to a flute, using a physical model developed from Perry Cook, but re-coded for Csound.';
html: 'wgflute.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'wgpluck';
spec: 'a wgpluck iikiiia';
fullSpec: 'ar wgpluck icps, iamp, kpick, iplk, idamp, ifilt, axcite';
doc: 'A high fidelity simulation of a plucked string, using interpolating delay-lines.';
html: 'wgpluck.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'wgpluck2';
spec: 'a wgpluck2 ikikk';
fullSpec: 'ar wgpluck2 iplk, kamp, icps, kpick, krefl';
doc: 'wgpluck2 is an implementation of the physical model of the plucked string, with control over the pluck point, the pickup point and the filter. Based on the Karplus-Strong algorithm.';
html: 'wgpluck2.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'wguide1';
spec: 'a wguide1 axkk';
fullSpec: 'ar wguide1 asig, xfreq, kcutoff, kfeedback';
doc: 'A simple waveguide model consisting of one delay-line and one first-order lowpass filter.';
html: 'wguide1.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'wguide2';
spec: 'a wguide2 axxkkkk';
fullSpec: 'ar wguide2 asig, xfreq1, xfreq2, kcutoff1, kcutoff2, kfeedback1, kfeedback2';
doc: 'A model of beaten plate consisting of two parallel delay-lines and two first-order lowpass filters.';
html: 'wguide2.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'wrap';
spec: 'x wrap xxx';
fullSpec: 'ar wrap asig, klow, khigh
ir wrap isig, ilow, ihigh
kr wrap ksig, klow, khigh';
doc: 'Wraps-around the signal that exceeds the low and high thresholds.';
html: 'wrap.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'wterrain';
spec: 'a wterrain kkkkkkii';
fullSpec: 'aout wterrain kamp, kpch, k_xcenter, k_ycenter, k_xradius, k_yradius, itabx, itaby';
doc: 'A simple wave-terrain synthesis opcode.';
html: 'wterrain.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'xadsr';
spec: 'x xadsr iiiii';
fullSpec: 'ar xadsr iatt, idec, islev, irel [, idel]
kr xadsr iatt, idec, islev, irel [, idel]';
doc: 'Calculates the classical ADSR envelope';
html: 'xadsr.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'xin';
spec: 'xxx xin ';
fullSpec: 'xinarg1 [, xinarg2] ... [xinargN] xin';
doc: 'The xin and xout opcodes copy variables to and from the opcode definition, allowing communication with the calling instrument.';
html: 'xin.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'xout';
spec: ' xout xxx';
fullSpec: 'xout xoutarg1 [, xoutarg2] ... [, xoutargN]';
doc: 'The xin and xout opcodes copy variables to and from the opcode definition, allowing communication with the calling instrument.';
html: 'xout.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'xscanmap';
spec: 'kk xscanmap ikki';
fullSpec: 'kpos, kvel xscanmap iscan, kamp, kvamp [, iwhich]';
doc: 'Allows the position and velocity of a node in a scanned process to be read.';
html: 'xscanmap.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'xscans';
spec: 'a xscans kkiii';
fullSpec: 'ar xscans kamp, kfreq, ifntraj, id [, iorder]';
doc: 'Experimental version of scans.  Allows much larger matrices and is faster and smaller but removes some (unused?) flexibility.  If liked, it will replace the older opcode as it is syntax compatible but extended.';
html: 'xscans.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'xscansmap';
spec: ' xscansmap kkikki';
fullSpec: 'xscansmap kpos, kvel, iscan, kamp, kvamp [, iwhich]';
doc: 'Allows the position and velocity of a node in a scanned process to be read.';
html: 'xscansmap.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'xscanu';
spec: ' xscanu iiiiiiikkkkiikkaii';
fullSpec: 'xscanu init, irate, ifnvel, ifnmass, ifnstif, ifncentr, ifndamp, kmass, kstif, kcentr, kdamp, ileft, iright, kpos, kstrngth, ain, idisp, id';
doc: 'Experimental version of scanu. Allows much larger matrices and is faster and smaller but removes some (unused?) flexibility.  If liked, it will replace the older opcode as it is syntax compatible but extended.';
html: 'xscanu.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'xtratim';
spec: ' xtratim i';
fullSpec: 'xtratim iextradur';
doc: 'Extend the duration of real-time generated events and handle their extra life (see also linenr).';
html: 'xtratim.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'xyin';
spec: 'kk xyin iiiiiii';
fullSpec: 'kx, ky xyin iprd, ixmin, ixmax, iymin, iymax [, ixinit] [, iyinit]';
doc: 'Sense the cursor position in an output window. When xyin is called the position of the mouse within the output window is used to reply to the request.  This simple mechanism does mean that only one xyin can be used accurately at once.  The position of the mouse is reported in the output window.';
html: 'xyin.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'zacl';
spec: ' zacl kk';
fullSpec: 'zacl kfirst, klast';
doc: 'Clears one or more variables in the za space.';
html: 'zacl.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'zakinit';
spec: ' zakinit ii';
fullSpec: 'zakinit isizea, isizek';
doc: 'Establishes zak space. Must be called only once.';
html: 'zakinit.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'zamod';
spec: 'a zamod ak';
fullSpec: 'ar zamod asig, kzamod';
doc: 'Modulates one a-rate signal by a second one.';
html: 'zamod.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'zar';
spec: 'a zar k';
fullSpec: 'ar zar kndx';
doc: 'Reads from a location in za space at a-rate.';
html: 'zar.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'zarg';
spec: 'a zarg kk';
fullSpec: 'ar zarg kndx, kgain';
doc: 'Reads from a location in za space at a-rate, adds some gain.';
html: 'zarg.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'zaw';
spec: ' zaw ak';
fullSpec: 'zaw asig, kndx';
doc: 'Writes to a za variable at a-rate without mixing.';
html: 'zaw.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'zawm';
spec: ' zawm aki';
fullSpec: 'zawm asig, kndx [, imix]';
doc: 'Writes to a za variable at a-rate with mixing.';
html: 'zawm.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'zfilter2';
spec: 'a zfilter2 akkiiiiiiii';
fullSpec: 'ar zfilter2 asig, kdamp, kfreq, iM, iN, ib0, ib1, ..., ibM, ia1,ia2, ..., iaN';
doc: 'General purpose custom filter with time-varying pole control. The filter coefficients implement the following difference equation:      (1)*y(n)&nbsp;=&nbsp;b0*x[n]&nbsp;+&nbsp;b1*x[n-1]&nbsp;+...+&nbsp;bM*x[n-M]&nbsp;-&nbsp;a1*y[n-1]&nbsp;-...-&nbsp;aN*y[n-N]&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
html: 'zfilter2.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'zir';
spec: 'i zir i';
fullSpec: 'ir zir indx';
doc: 'Reads from a location in zk space at i-rate.';
html: 'zir.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'ziw';
spec: ' ziw ii';
fullSpec: 'ziw isig, indx';
doc: 'Writes to a zk variable at i-rate without mixing.';
html: 'ziw.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'ziwm';
spec: ' ziwm iii';
fullSpec: 'ziwm isig, indx [, imix]';
doc: 'Writes to a zk variable to an i-rate variable with mixing.';
html: 'ziwm.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'zkcl';
spec: ' zkcl kk';
fullSpec: 'zkcl kfirst, klast';
doc: 'Clears one or more variables in the zk space.';
html: 'zkcl.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'zkmod';
spec: 'k zkmod kk';
fullSpec: 'kr zkmod ksig, kzkmod';
doc: 'Facilitates the modulation of one signal by another.';
html: 'zkmod.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'zkr';
spec: 'k zkr k';
fullSpec: 'kr zkr kndx';
doc: 'Reads from a location in zk space at k-rate.';
html: 'zkr.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'zkw';
spec: ' zkw kk';
fullSpec: 'zkw ksig, kndx';
doc: 'Writes to a zk variable at k-rate without mixing.';
html: 'zkw.html')!

''!CsoundOpcode registerOpcode: ((CsoundOpcode new)
name: 'zkwm';
spec: ' zkwm kki';
fullSpec: 'zkwm ksig, kndx [, imix]';
doc: 'Writes to a zk variable at k-rate with mixing.';
html: 'zkwm.html')!

''!CsoundOpcode HTMLpath: 'manual\'!
